#!/bin/bash

if [ "$1" == "" ]; then echo "usage: /home/v4l/media_build/devel_scripts/gen_rename_patch.pl <in_patch>"; exit -1; fi

OLD="$1.old"
mv $1 $OLD && cat $OLD | sed -e 's,drivers/media/dvb/b2c2/Kconfig,drivers/media/common/b2c2/Kconfig,g' \
	-e 's,include/linux/dvb/ca\.h,include/uapi/linux/dvb/ca\.h,g' \
	-e 's,include/linux/dvb/frontend\.h,include/uapi/linux/dvb/frontend\.h,g' \
	-e 's,include/linux/dvb/net\.h,include/uapi/linux/dvb/net\.h,g' \
	-e 's,include/linux/dvb/osd\.h,include/uapi/linux/dvb/osd\.h,g' \
	-e 's,include/linux/dvb/version\.h,include/uapi/linux/dvb/version\.h,g' \
	-e 's,include/linux/ivtvfb\.h,include/uapi/linux/ivtvfb\.h,g' \
	-e 's,include/linux/ivtv\.h,include/uapi/linux/ivtv\.h,g' \
	-e 's,include/linux/media\.h,include/uapi/linux/media\.h,g' \
	-e 's,include/linux/meye\.h,include/uapi/linux/meye\.h,g' \
	-e 's,include/linux/uvcvideo\.h,include/uapi/linux/uvcvideo\.h,g' \
	-e 's,include/linux/v4l2-common\.h,include/uapi/linux/v4l2-common\.h,g' \
	-e 's,include/linux/v4l2-controls\.h,include/uapi/linux/v4l2-controls\.h,g' \
	-e 's,include/linux/v4l2-dv-timings\.h,include/uapi/linux/v4l2-dv-timings\.h,g' \
	-e 's,include/linux/v4l2-mediabus\.h,include/uapi/linux/v4l2-mediabus\.h,g' \
	-e 's,include/linux/v4l2-subdev\.h,include/uapi/linux/v4l2-subdev\.h,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop-common\.h,drivers/media/common/b2c2/flexcop-common\.h,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop-eeprom\.c,drivers/media/common/b2c2/flexcop-eeprom\.c,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop-fe-tuner\.c,drivers/media/common/b2c2/flexcop-fe-tuner\.c,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop-hw-filter\.c,drivers/media/common/b2c2/flexcop-hw-filter\.c,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop-i2c\.c,drivers/media/common/b2c2/flexcop-i2c\.c,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop-misc\.c,drivers/media/common/b2c2/flexcop-misc\.c,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop-reg\.h,drivers/media/common/b2c2/flexcop-reg\.h,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop-sram\.c,drivers/media/common/b2c2/flexcop-sram\.c,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop\.c,drivers/media/common/b2c2/flexcop\.c,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop\.h,drivers/media/common/b2c2/flexcop\.h,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop_ibi_value_be\.h,drivers/media/common/b2c2/flexcop_ibi_value_be\.h,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop_ibi_value_le\.h,drivers/media/common/b2c2/flexcop_ibi_value_le\.h,g' \
	-e 's,drivers/media/common/saa7146_core\.c,drivers/media/common/saa7146/saa7146_core\.c,g' \
	-e 's,drivers/media/common/saa7146_fops\.c,drivers/media/common/saa7146/saa7146_fops\.c,g' \
	-e 's,drivers/media/common/saa7146_hlp\.c,drivers/media/common/saa7146/saa7146_hlp\.c,g' \
	-e 's,drivers/media/common/saa7146_i2c\.c,drivers/media/common/saa7146/saa7146_i2c\.c,g' \
	-e 's,drivers/media/common/saa7146_vbi\.c,drivers/media/common/saa7146/saa7146_vbi\.c,g' \
	-e 's,drivers/media/common/saa7146_video\.c,drivers/media/common/saa7146/saa7146_video\.c,g' \
	-e 's,drivers/media/dvb/siano/Kconfig,drivers/media/common/siano/Kconfig,g' \
	-e 's,drivers/media/dvb/siano/Makefile,drivers/media/common/siano/Makefile,g' \
	-e 's,drivers/media/dvb/siano/sms-cards\.c,drivers/media/common/siano/sms-cards\.c,g' \
	-e 's,drivers/media/dvb/siano/sms-cards\.h,drivers/media/common/siano/sms-cards\.h,g' \
	-e 's,drivers/media/dvb/siano/smscoreapi\.c,drivers/media/common/siano/smscoreapi\.c,g' \
	-e 's,drivers/media/dvb/siano/smscoreapi\.h,drivers/media/common/siano/smscoreapi\.h,g' \
	-e 's,drivers/media/dvb/siano/smsdvb\.c,drivers/media/common/siano/smsdvb\.c,g' \
	-e 's,drivers/media/dvb/siano/smsendian\.c,drivers/media/common/siano/smsendian\.c,g' \
	-e 's,drivers/media/dvb/siano/smsendian\.h,drivers/media/common/siano/smsendian\.h,g' \
	-e 's,drivers/media/dvb/siano/smsir\.c,drivers/media/common/siano/smsir\.c,g' \
	-e 's,drivers/media/dvb/siano/smsir\.h,drivers/media/common/siano/smsir\.h,g' \
	-e 's,drivers/media/dvb/Kconfig,drivers/media/dvb-core/Kconfig,g' \
	-e 's,drivers/media/dvb/dvb-core/Makefile,drivers/media/dvb-core/Makefile,g' \
	-e 's,drivers/media/dvb/dvb-core/demux\.h,drivers/media/dvb-core/demux\.h,g' \
	-e 's,drivers/media/dvb/dvb-core/dmxdev\.c,drivers/media/dvb-core/dmxdev\.c,g' \
	-e 's,drivers/media/dvb/dvb-core/dmxdev\.h,drivers/media/dvb-core/dmxdev\.h,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb-usb-ids\.h,drivers/media/dvb-core/dvb-usb-ids\.h,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_ca_en50221\.c,drivers/media/dvb-core/dvb_ca_en50221\.c,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_ca_en50221\.h,drivers/media/dvb-core/dvb_ca_en50221\.h,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_demux\.c,drivers/media/dvb-core/dvb_demux\.c,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_demux\.h,drivers/media/dvb-core/dvb_demux\.h,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_filter\.c,drivers/media/dvb-core/dvb_filter\.c,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_filter\.h,drivers/media/dvb-core/dvb_filter\.h,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_frontend\.c,drivers/media/dvb-core/dvb_frontend\.c,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_frontend\.h,drivers/media/dvb-core/dvb_frontend\.h,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_math\.c,drivers/media/dvb-core/dvb_math\.c,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_math\.h,drivers/media/dvb-core/dvb_math\.h,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_net\.c,drivers/media/dvb-core/dvb_net\.c,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_net\.h,drivers/media/dvb-core/dvb_net\.h,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_ringbuffer\.c,drivers/media/dvb-core/dvb_ringbuffer\.c,g' \
	-e 's,drivers/media/dvb/dvb-core/dvb_ringbuffer\.h,drivers/media/dvb-core/dvb_ringbuffer\.h,g' \
	-e 's,drivers/media/dvb/dvb-core/dvbdev\.c,drivers/media/dvb-core/dvbdev\.c,g' \
	-e 's,drivers/media/dvb/dvb-core/dvbdev\.h,drivers/media/dvb-core/dvbdev\.h,g' \
	-e 's,drivers/media/dvb/frontends/Kconfig,drivers/media/dvb-frontends/Kconfig,g' \
	-e 's,drivers/media/dvb/frontends/Makefile,drivers/media/dvb-frontends/Makefile,g' \
	-e 's,drivers/media/dvb/frontends/a8293\.c,drivers/media/dvb-frontends/a8293\.c,g' \
	-e 's,drivers/media/dvb/frontends/a8293\.h,drivers/media/dvb-frontends/a8293\.h,g' \
	-e 's,drivers/media/dvb/frontends/af9013\.c,drivers/media/dvb-frontends/af9013\.c,g' \
	-e 's,drivers/media/dvb/frontends/af9013\.h,drivers/media/dvb-frontends/af9013\.h,g' \
	-e 's,drivers/media/dvb/frontends/af9013_priv\.h,drivers/media/dvb-frontends/af9013_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/af9033\.c,drivers/media/dvb-frontends/af9033\.c,g' \
	-e 's,drivers/media/dvb/frontends/af9033\.h,drivers/media/dvb-frontends/af9033\.h,g' \
	-e 's,drivers/media/dvb/frontends/af9033_priv\.h,drivers/media/dvb-frontends/af9033_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/atbm8830\.c,drivers/media/dvb-frontends/atbm8830\.c,g' \
	-e 's,drivers/media/dvb/frontends/atbm8830\.h,drivers/media/dvb-frontends/atbm8830\.h,g' \
	-e 's,drivers/media/dvb/frontends/atbm8830_priv\.h,drivers/media/dvb-frontends/atbm8830_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/au8522\.h,drivers/media/dvb-frontends/au8522\.h,g' \
	-e 's,drivers/media/dvb/frontends/au8522_common\.c,drivers/media/dvb-frontends/au8522_common\.c,g' \
	-e 's,drivers/media/dvb/frontends/au8522_decoder\.c,drivers/media/dvb-frontends/au8522_decoder\.c,g' \
	-e 's,drivers/media/dvb/frontends/au8522_dig\.c,drivers/media/dvb-frontends/au8522_dig\.c,g' \
	-e 's,drivers/media/dvb/frontends/au8522_priv\.h,drivers/media/dvb-frontends/au8522_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/bcm3510\.c,drivers/media/dvb-frontends/bcm3510\.c,g' \
	-e 's,drivers/media/dvb/frontends/bcm3510\.h,drivers/media/dvb-frontends/bcm3510\.h,g' \
	-e 's,drivers/media/dvb/frontends/bcm3510_priv\.h,drivers/media/dvb-frontends/bcm3510_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/bsbe1-d01a\.h,drivers/media/dvb-frontends/bsbe1-d01a\.h,g' \
	-e 's,drivers/media/dvb/frontends/bsbe1\.h,drivers/media/dvb-frontends/bsbe1\.h,g' \
	-e 's,drivers/media/dvb/frontends/bsru6\.h,drivers/media/dvb-frontends/bsru6\.h,g' \
	-e 's,drivers/media/dvb/frontends/cx22700\.c,drivers/media/dvb-frontends/cx22700\.c,g' \
	-e 's,drivers/media/dvb/frontends/cx22700\.h,drivers/media/dvb-frontends/cx22700\.h,g' \
	-e 's,drivers/media/dvb/frontends/cx22702\.c,drivers/media/dvb-frontends/cx22702\.c,g' \
	-e 's,drivers/media/dvb/frontends/cx22702\.h,drivers/media/dvb-frontends/cx22702\.h,g' \
	-e 's,drivers/media/dvb/frontends/cx24110\.c,drivers/media/dvb-frontends/cx24110\.c,g' \
	-e 's,drivers/media/dvb/frontends/cx24110\.h,drivers/media/dvb-frontends/cx24110\.h,g' \
	-e 's,drivers/media/dvb/frontends/cx24113\.c,drivers/media/dvb-frontends/cx24113\.c,g' \
	-e 's,drivers/media/dvb/frontends/cx24113\.h,drivers/media/dvb-frontends/cx24113\.h,g' \
	-e 's,drivers/media/dvb/frontends/cx24116\.c,drivers/media/dvb-frontends/cx24116\.c,g' \
	-e 's,drivers/media/dvb/frontends/cx24116\.h,drivers/media/dvb-frontends/cx24116\.h,g' \
	-e 's,drivers/media/dvb/frontends/cx24123\.c,drivers/media/dvb-frontends/cx24123\.c,g' \
	-e 's,drivers/media/dvb/frontends/cx24123\.h,drivers/media/dvb-frontends/cx24123\.h,g' \
	-e 's,drivers/media/dvb/frontends/cxd2820r\.h,drivers/media/dvb-frontends/cxd2820r\.h,g' \
	-e 's,drivers/media/dvb/frontends/cxd2820r_c\.c,drivers/media/dvb-frontends/cxd2820r_c\.c,g' \
	-e 's,drivers/media/dvb/frontends/cxd2820r_core\.c,drivers/media/dvb-frontends/cxd2820r_core\.c,g' \
	-e 's,drivers/media/dvb/frontends/cxd2820r_priv\.h,drivers/media/dvb-frontends/cxd2820r_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/cxd2820r_t\.c,drivers/media/dvb-frontends/cxd2820r_t\.c,g' \
	-e 's,drivers/media/dvb/frontends/cxd2820r_t2\.c,drivers/media/dvb-frontends/cxd2820r_t2\.c,g' \
	-e 's,drivers/media/dvb/frontends/dib0070\.c,drivers/media/dvb-frontends/dib0070\.c,g' \
	-e 's,drivers/media/dvb/frontends/dib0070\.h,drivers/media/dvb-frontends/dib0070\.h,g' \
	-e 's,drivers/media/dvb/frontends/dib0090\.c,drivers/media/dvb-frontends/dib0090\.c,g' \
	-e 's,drivers/media/dvb/frontends/dib0090\.h,drivers/media/dvb-frontends/dib0090\.h,g' \
	-e 's,drivers/media/dvb/frontends/dib3000\.h,drivers/media/dvb-frontends/dib3000\.h,g' \
	-e 's,drivers/media/dvb/frontends/dib3000mb\.c,drivers/media/dvb-frontends/dib3000mb\.c,g' \
	-e 's,drivers/media/dvb/frontends/dib3000mb_priv\.h,drivers/media/dvb-frontends/dib3000mb_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/dib3000mc\.c,drivers/media/dvb-frontends/dib3000mc\.c,g' \
	-e 's,drivers/media/dvb/frontends/dib3000mc\.h,drivers/media/dvb-frontends/dib3000mc\.h,g' \
	-e 's,drivers/media/dvb/frontends/dib7000m\.c,drivers/media/dvb-frontends/dib7000m\.c,g' \
	-e 's,drivers/media/dvb/frontends/dib7000m\.h,drivers/media/dvb-frontends/dib7000m\.h,g' \
	-e 's,drivers/media/dvb/frontends/dib7000p\.c,drivers/media/dvb-frontends/dib7000p\.c,g' \
	-e 's,drivers/media/dvb/frontends/dib7000p\.h,drivers/media/dvb-frontends/dib7000p\.h,g' \
	-e 's,drivers/media/dvb/frontends/dib8000\.c,drivers/media/dvb-frontends/dib8000\.c,g' \
	-e 's,drivers/media/dvb/frontends/dib8000\.h,drivers/media/dvb-frontends/dib8000\.h,g' \
	-e 's,drivers/media/dvb/frontends/dib9000\.c,drivers/media/dvb-frontends/dib9000\.c,g' \
	-e 's,drivers/media/dvb/frontends/dib9000\.h,drivers/media/dvb-frontends/dib9000\.h,g' \
	-e 's,drivers/media/dvb/frontends/dibx000_common\.c,drivers/media/dvb-frontends/dibx000_common\.c,g' \
	-e 's,drivers/media/dvb/frontends/dibx000_common\.h,drivers/media/dvb-frontends/dibx000_common\.h,g' \
	-e 's,drivers/media/dvb/frontends/drxd\.h,drivers/media/dvb-frontends/drxd\.h,g' \
	-e 's,drivers/media/dvb/frontends/drxd_firm\.c,drivers/media/dvb-frontends/drxd_firm\.c,g' \
	-e 's,drivers/media/dvb/frontends/drxd_firm\.h,drivers/media/dvb-frontends/drxd_firm\.h,g' \
	-e 's,drivers/media/dvb/frontends/drxd_hard\.c,drivers/media/dvb-frontends/drxd_hard\.c,g' \
	-e 's,drivers/media/dvb/frontends/drxd_map_firm\.h,drivers/media/dvb-frontends/drxd_map_firm\.h,g' \
	-e 's,drivers/media/dvb/frontends/drxk\.h,drivers/media/dvb-frontends/drxk\.h,g' \
	-e 's,drivers/media/dvb/frontends/drxk_hard\.c,drivers/media/dvb-frontends/drxk_hard\.c,g' \
	-e 's,drivers/media/dvb/frontends/drxk_hard\.h,drivers/media/dvb-frontends/drxk_hard\.h,g' \
	-e 's,drivers/media/dvb/frontends/drxk_map\.h,drivers/media/dvb-frontends/drxk_map\.h,g' \
	-e 's,drivers/media/dvb/frontends/ds3000\.c,drivers/media/dvb-frontends/ds3000\.c,g' \
	-e 's,drivers/media/dvb/frontends/ds3000\.h,drivers/media/dvb-frontends/ds3000\.h,g' \
	-e 's,drivers/media/dvb/frontends/dvb-pll\.c,drivers/media/dvb-frontends/dvb-pll\.c,g' \
	-e 's,drivers/media/dvb/frontends/dvb-pll\.h,drivers/media/dvb-frontends/dvb-pll\.h,g' \
	-e 's,drivers/media/dvb/frontends/dvb_dummy_fe\.c,drivers/media/dvb-frontends/dvb_dummy_fe\.c,g' \
	-e 's,drivers/media/dvb/frontends/dvb_dummy_fe\.h,drivers/media/dvb-frontends/dvb_dummy_fe\.h,g' \
	-e 's,drivers/media/dvb/frontends/ec100\.c,drivers/media/dvb-frontends/ec100\.c,g' \
	-e 's,drivers/media/dvb/frontends/ec100\.h,drivers/media/dvb-frontends/ec100\.h,g' \
	-e 's,drivers/media/dvb/frontends/ec100_priv\.h,drivers/media/dvb-frontends/ec100_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/eds1547\.h,drivers/media/dvb-frontends/eds1547\.h,g' \
	-e 's,drivers/media/dvb/frontends/hd29l2\.c,drivers/media/dvb-frontends/hd29l2\.c,g' \
	-e 's,drivers/media/dvb/frontends/hd29l2\.h,drivers/media/dvb-frontends/hd29l2\.h,g' \
	-e 's,drivers/media/dvb/frontends/hd29l2_priv\.h,drivers/media/dvb-frontends/hd29l2_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/isl6405\.c,drivers/media/dvb-frontends/isl6405\.c,g' \
	-e 's,drivers/media/dvb/frontends/isl6405\.h,drivers/media/dvb-frontends/isl6405\.h,g' \
	-e 's,drivers/media/dvb/frontends/isl6421\.c,drivers/media/dvb-frontends/isl6421\.c,g' \
	-e 's,drivers/media/dvb/frontends/isl6421\.h,drivers/media/dvb-frontends/isl6421\.h,g' \
	-e 's,drivers/media/dvb/frontends/isl6423\.c,drivers/media/dvb-frontends/isl6423\.c,g' \
	-e 's,drivers/media/dvb/frontends/isl6423\.h,drivers/media/dvb-frontends/isl6423\.h,g' \
	-e 's,drivers/media/dvb/frontends/it913x-fe-priv\.h,drivers/media/dvb-frontends/it913x-fe-priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/it913x-fe\.c,drivers/media/dvb-frontends/it913x-fe\.c,g' \
	-e 's,drivers/media/dvb/frontends/it913x-fe\.h,drivers/media/dvb-frontends/it913x-fe\.h,g' \
	-e 's,drivers/media/dvb/frontends/itd1000\.c,drivers/media/dvb-frontends/itd1000\.c,g' \
	-e 's,drivers/media/dvb/frontends/itd1000\.h,drivers/media/dvb-frontends/itd1000\.h,g' \
	-e 's,drivers/media/dvb/frontends/itd1000_priv\.h,drivers/media/dvb-frontends/itd1000_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/ix2505v\.c,drivers/media/dvb-frontends/ix2505v\.c,g' \
	-e 's,drivers/media/dvb/frontends/ix2505v\.h,drivers/media/dvb-frontends/ix2505v\.h,g' \
	-e 's,drivers/media/dvb/frontends/l64781\.c,drivers/media/dvb-frontends/l64781\.c,g' \
	-e 's,drivers/media/dvb/frontends/l64781\.h,drivers/media/dvb-frontends/l64781\.h,g' \
	-e 's,drivers/media/dvb/frontends/lg2160\.c,drivers/media/dvb-frontends/lg2160\.c,g' \
	-e 's,drivers/media/dvb/frontends/lg2160\.h,drivers/media/dvb-frontends/lg2160\.h,g' \
	-e 's,drivers/media/dvb/frontends/lgdt3305\.c,drivers/media/dvb-frontends/lgdt3305\.c,g' \
	-e 's,drivers/media/dvb/frontends/lgdt3305\.h,drivers/media/dvb-frontends/lgdt3305\.h,g' \
	-e 's,drivers/media/dvb/frontends/lgdt330x\.c,drivers/media/dvb-frontends/lgdt330x\.c,g' \
	-e 's,drivers/media/dvb/frontends/lgdt330x\.h,drivers/media/dvb-frontends/lgdt330x\.h,g' \
	-e 's,drivers/media/dvb/frontends/lgdt330x_priv\.h,drivers/media/dvb-frontends/lgdt330x_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/lgs8gl5\.c,drivers/media/dvb-frontends/lgs8gl5\.c,g' \
	-e 's,drivers/media/dvb/frontends/lgs8gl5\.h,drivers/media/dvb-frontends/lgs8gl5\.h,g' \
	-e 's,drivers/media/dvb/frontends/lgs8gxx\.c,drivers/media/dvb-frontends/lgs8gxx\.c,g' \
	-e 's,drivers/media/dvb/frontends/lgs8gxx\.h,drivers/media/dvb-frontends/lgs8gxx\.h,g' \
	-e 's,drivers/media/dvb/frontends/lgs8gxx_priv\.h,drivers/media/dvb-frontends/lgs8gxx_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/lnbh24\.h,drivers/media/dvb-frontends/lnbh24\.h,g' \
	-e 's,drivers/media/dvb/frontends/lnbp21\.c,drivers/media/dvb-frontends/lnbp21\.c,g' \
	-e 's,drivers/media/dvb/frontends/lnbp21\.h,drivers/media/dvb-frontends/lnbp21\.h,g' \
	-e 's,drivers/media/dvb/frontends/lnbp22\.c,drivers/media/dvb-frontends/lnbp22\.c,g' \
	-e 's,drivers/media/dvb/frontends/lnbp22\.h,drivers/media/dvb-frontends/lnbp22\.h,g' \
	-e 's,drivers/media/dvb/frontends/m88rs2000\.c,drivers/media/dvb-frontends/m88rs2000\.c,g' \
	-e 's,drivers/media/dvb/frontends/m88rs2000\.h,drivers/media/dvb-frontends/m88rs2000\.h,g' \
	-e 's,drivers/media/dvb/frontends/mb86a16\.c,drivers/media/dvb-frontends/mb86a16\.c,g' \
	-e 's,drivers/media/dvb/frontends/mb86a16\.h,drivers/media/dvb-frontends/mb86a16\.h,g' \
	-e 's,drivers/media/dvb/frontends/mb86a16_priv\.h,drivers/media/dvb-frontends/mb86a16_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/mb86a20s\.c,drivers/media/dvb-frontends/mb86a20s\.c,g' \
	-e 's,drivers/media/dvb/frontends/mb86a20s\.h,drivers/media/dvb-frontends/mb86a20s\.h,g' \
	-e 's,drivers/media/dvb/frontends/mt312\.c,drivers/media/dvb-frontends/mt312\.c,g' \
	-e 's,drivers/media/dvb/frontends/mt312\.h,drivers/media/dvb-frontends/mt312\.h,g' \
	-e 's,drivers/media/dvb/frontends/mt312_priv\.h,drivers/media/dvb-frontends/mt312_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/mt352\.c,drivers/media/dvb-frontends/mt352\.c,g' \
	-e 's,drivers/media/dvb/frontends/mt352\.h,drivers/media/dvb-frontends/mt352\.h,g' \
	-e 's,drivers/media/dvb/frontends/mt352_priv\.h,drivers/media/dvb-frontends/mt352_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/nxt200x\.c,drivers/media/dvb-frontends/nxt200x\.c,g' \
	-e 's,drivers/media/dvb/frontends/nxt200x\.h,drivers/media/dvb-frontends/nxt200x\.h,g' \
	-e 's,drivers/media/dvb/frontends/nxt6000\.c,drivers/media/dvb-frontends/nxt6000\.c,g' \
	-e 's,drivers/media/dvb/frontends/nxt6000\.h,drivers/media/dvb-frontends/nxt6000\.h,g' \
	-e 's,drivers/media/dvb/frontends/nxt6000_priv\.h,drivers/media/dvb-frontends/nxt6000_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/or51132\.c,drivers/media/dvb-frontends/or51132\.c,g' \
	-e 's,drivers/media/dvb/frontends/or51132\.h,drivers/media/dvb-frontends/or51132\.h,g' \
	-e 's,drivers/media/dvb/frontends/or51211\.c,drivers/media/dvb-frontends/or51211\.c,g' \
	-e 's,drivers/media/dvb/frontends/or51211\.h,drivers/media/dvb-frontends/or51211\.h,g' \
	-e 's,drivers/media/dvb/frontends/rtl2830\.c,drivers/media/dvb-frontends/rtl2830\.c,g' \
	-e 's,drivers/media/dvb/frontends/rtl2830\.h,drivers/media/dvb-frontends/rtl2830\.h,g' \
	-e 's,drivers/media/dvb/frontends/rtl2830_priv\.h,drivers/media/dvb-frontends/rtl2830_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/rtl2832\.c,drivers/media/dvb-frontends/rtl2832\.c,g' \
	-e 's,drivers/media/dvb/frontends/rtl2832\.h,drivers/media/dvb-frontends/rtl2832\.h,g' \
	-e 's,drivers/media/dvb/frontends/rtl2832_priv\.h,drivers/media/dvb-frontends/rtl2832_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/s5h1409\.c,drivers/media/dvb-frontends/s5h1409\.c,g' \
	-e 's,drivers/media/dvb/frontends/s5h1409\.h,drivers/media/dvb-frontends/s5h1409\.h,g' \
	-e 's,drivers/media/dvb/frontends/s5h1411\.c,drivers/media/dvb-frontends/s5h1411\.c,g' \
	-e 's,drivers/media/dvb/frontends/s5h1411\.h,drivers/media/dvb-frontends/s5h1411\.h,g' \
	-e 's,drivers/media/dvb/frontends/s5h1420\.c,drivers/media/dvb-frontends/s5h1420\.c,g' \
	-e 's,drivers/media/dvb/frontends/s5h1420\.h,drivers/media/dvb-frontends/s5h1420\.h,g' \
	-e 's,drivers/media/dvb/frontends/s5h1420_priv\.h,drivers/media/dvb-frontends/s5h1420_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/s5h1432\.c,drivers/media/dvb-frontends/s5h1432\.c,g' \
	-e 's,drivers/media/dvb/frontends/s5h1432\.h,drivers/media/dvb-frontends/s5h1432\.h,g' \
	-e 's,drivers/media/dvb/frontends/s921\.c,drivers/media/dvb-frontends/s921\.c,g' \
	-e 's,drivers/media/dvb/frontends/s921\.h,drivers/media/dvb-frontends/s921\.h,g' \
	-e 's,drivers/media/dvb/frontends/si21xx\.c,drivers/media/dvb-frontends/si21xx\.c,g' \
	-e 's,drivers/media/dvb/frontends/si21xx\.h,drivers/media/dvb-frontends/si21xx\.h,g' \
	-e 's,drivers/media/dvb/frontends/sp8870\.c,drivers/media/dvb-frontends/sp8870\.c,g' \
	-e 's,drivers/media/dvb/frontends/sp8870\.h,drivers/media/dvb-frontends/sp8870\.h,g' \
	-e 's,drivers/media/dvb/frontends/sp887x\.c,drivers/media/dvb-frontends/sp887x\.c,g' \
	-e 's,drivers/media/dvb/frontends/sp887x\.h,drivers/media/dvb-frontends/sp887x\.h,g' \
	-e 's,drivers/media/dvb/frontends/stb0899_algo\.c,drivers/media/dvb-frontends/stb0899_algo\.c,g' \
	-e 's,drivers/media/dvb/frontends/stb0899_cfg\.h,drivers/media/dvb-frontends/stb0899_cfg\.h,g' \
	-e 's,drivers/media/dvb/frontends/stb0899_drv\.c,drivers/media/dvb-frontends/stb0899_drv\.c,g' \
	-e 's,drivers/media/dvb/frontends/stb0899_drv\.h,drivers/media/dvb-frontends/stb0899_drv\.h,g' \
	-e 's,drivers/media/dvb/frontends/stb0899_priv\.h,drivers/media/dvb-frontends/stb0899_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/stb0899_reg\.h,drivers/media/dvb-frontends/stb0899_reg\.h,g' \
	-e 's,drivers/media/dvb/frontends/stb6000\.c,drivers/media/dvb-frontends/stb6000\.c,g' \
	-e 's,drivers/media/dvb/frontends/stb6000\.h,drivers/media/dvb-frontends/stb6000\.h,g' \
	-e 's,drivers/media/dvb/frontends/stb6100\.c,drivers/media/dvb-frontends/stb6100\.c,g' \
	-e 's,drivers/media/dvb/frontends/stb6100\.h,drivers/media/dvb-frontends/stb6100\.h,g' \
	-e 's,drivers/media/dvb/frontends/stb6100_cfg\.h,drivers/media/dvb-frontends/stb6100_cfg\.h,g' \
	-e 's,drivers/media/dvb/frontends/stb6100_proc\.h,drivers/media/dvb-frontends/stb6100_proc\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv0288\.c,drivers/media/dvb-frontends/stv0288\.c,g' \
	-e 's,drivers/media/dvb/frontends/stv0288\.h,drivers/media/dvb-frontends/stv0288\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv0297\.c,drivers/media/dvb-frontends/stv0297\.c,g' \
	-e 's,drivers/media/dvb/frontends/stv0297\.h,drivers/media/dvb-frontends/stv0297\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv0299\.c,drivers/media/dvb-frontends/stv0299\.c,g' \
	-e 's,drivers/media/dvb/frontends/stv0299\.h,drivers/media/dvb-frontends/stv0299\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv0367\.c,drivers/media/dvb-frontends/stv0367\.c,g' \
	-e 's,drivers/media/dvb/frontends/stv0367\.h,drivers/media/dvb-frontends/stv0367\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv0367_priv\.h,drivers/media/dvb-frontends/stv0367_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv0367_regs\.h,drivers/media/dvb-frontends/stv0367_regs\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv0900\.h,drivers/media/dvb-frontends/stv0900\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv0900_core\.c,drivers/media/dvb-frontends/stv0900_core\.c,g' \
	-e 's,drivers/media/dvb/frontends/stv0900_init\.h,drivers/media/dvb-frontends/stv0900_init\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv0900_priv\.h,drivers/media/dvb-frontends/stv0900_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv0900_reg\.h,drivers/media/dvb-frontends/stv0900_reg\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv0900_sw\.c,drivers/media/dvb-frontends/stv0900_sw\.c,g' \
	-e 's,drivers/media/dvb/frontends/stv090x\.c,drivers/media/dvb-frontends/stv090x\.c,g' \
	-e 's,drivers/media/dvb/frontends/stv090x\.h,drivers/media/dvb-frontends/stv090x\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv090x_priv\.h,drivers/media/dvb-frontends/stv090x_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv090x_reg\.h,drivers/media/dvb-frontends/stv090x_reg\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv6110\.c,drivers/media/dvb-frontends/stv6110\.c,g' \
	-e 's,drivers/media/dvb/frontends/stv6110\.h,drivers/media/dvb-frontends/stv6110\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv6110x\.c,drivers/media/dvb-frontends/stv6110x\.c,g' \
	-e 's,drivers/media/dvb/frontends/stv6110x\.h,drivers/media/dvb-frontends/stv6110x\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv6110x_priv\.h,drivers/media/dvb-frontends/stv6110x_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/stv6110x_reg\.h,drivers/media/dvb-frontends/stv6110x_reg\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda10021\.c,drivers/media/dvb-frontends/tda10021\.c,g' \
	-e 's,drivers/media/dvb/frontends/tda10023\.c,drivers/media/dvb-frontends/tda10023\.c,g' \
	-e 's,drivers/media/dvb/frontends/tda1002x\.h,drivers/media/dvb-frontends/tda1002x\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda10048\.c,drivers/media/dvb-frontends/tda10048\.c,g' \
	-e 's,drivers/media/dvb/frontends/tda10048\.h,drivers/media/dvb-frontends/tda10048\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda1004x\.c,drivers/media/dvb-frontends/tda1004x\.c,g' \
	-e 's,drivers/media/dvb/frontends/tda1004x\.h,drivers/media/dvb-frontends/tda1004x\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda10071\.c,drivers/media/dvb-frontends/tda10071\.c,g' \
	-e 's,drivers/media/dvb/frontends/tda10071\.h,drivers/media/dvb-frontends/tda10071\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda10071_priv\.h,drivers/media/dvb-frontends/tda10071_priv\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda10086\.c,drivers/media/dvb-frontends/tda10086\.c,g' \
	-e 's,drivers/media/dvb/frontends/tda10086\.h,drivers/media/dvb-frontends/tda10086\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda18271c2dd\.c,drivers/media/dvb-frontends/tda18271c2dd\.c,g' \
	-e 's,drivers/media/dvb/frontends/tda18271c2dd\.h,drivers/media/dvb-frontends/tda18271c2dd\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda18271c2dd_maps\.h,drivers/media/dvb-frontends/tda18271c2dd_maps\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda665x\.c,drivers/media/dvb-frontends/tda665x\.c,g' \
	-e 's,drivers/media/dvb/frontends/tda665x\.h,drivers/media/dvb-frontends/tda665x\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda8083\.c,drivers/media/dvb-frontends/tda8083\.c,g' \
	-e 's,drivers/media/dvb/frontends/tda8083\.h,drivers/media/dvb-frontends/tda8083\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda8261\.c,drivers/media/dvb-frontends/tda8261\.c,g' \
	-e 's,drivers/media/dvb/frontends/tda8261\.h,drivers/media/dvb-frontends/tda8261\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda8261_cfg\.h,drivers/media/dvb-frontends/tda8261_cfg\.h,g' \
	-e 's,drivers/media/dvb/frontends/tda826x\.c,drivers/media/dvb-frontends/tda826x\.c,g' \
	-e 's,drivers/media/dvb/frontends/tda826x\.h,drivers/media/dvb-frontends/tda826x\.h,g' \
	-e 's,drivers/media/dvb/frontends/tdhd1\.h,drivers/media/dvb-frontends/tdhd1\.h,g' \
	-e 's,drivers/media/dvb/frontends/tua6100\.c,drivers/media/dvb-frontends/tua6100\.c,g' \
	-e 's,drivers/media/dvb/frontends/tua6100\.h,drivers/media/dvb-frontends/tua6100\.h,g' \
	-e 's,drivers/media/dvb/frontends/ves1820\.c,drivers/media/dvb-frontends/ves1820\.c,g' \
	-e 's,drivers/media/dvb/frontends/ves1820\.h,drivers/media/dvb-frontends/ves1820\.h,g' \
	-e 's,drivers/media/dvb/frontends/ves1x93\.c,drivers/media/dvb-frontends/ves1x93\.c,g' \
	-e 's,drivers/media/dvb/frontends/ves1x93\.h,drivers/media/dvb-frontends/ves1x93\.h,g' \
	-e 's,drivers/media/dvb/frontends/z0194a\.h,drivers/media/dvb-frontends/z0194a\.h,g' \
	-e 's,drivers/media/dvb/frontends/zl10036\.c,drivers/media/dvb-frontends/zl10036\.c,g' \
	-e 's,drivers/media/dvb/frontends/zl10036\.h,drivers/media/dvb-frontends/zl10036\.h,g' \
	-e 's,drivers/media/dvb/frontends/zl10039\.c,drivers/media/dvb-frontends/zl10039\.c,g' \
	-e 's,drivers/media/dvb/frontends/zl10039\.h,drivers/media/dvb-frontends/zl10039\.h,g' \
	-e 's,drivers/media/dvb/frontends/zl10353\.c,drivers/media/dvb-frontends/zl10353\.c,g' \
	-e 's,drivers/media/dvb/frontends/zl10353\.h,drivers/media/dvb-frontends/zl10353\.h,g' \
	-e 's,drivers/media/dvb/frontends/zl10353_priv\.h,drivers/media/dvb-frontends/zl10353_priv\.h,g' \
	-e 's,drivers/media/dvb/firewire/Kconfig,drivers/media/firewire/Kconfig,g' \
	-e 's,drivers/media/dvb/firewire/Makefile,drivers/media/firewire/Makefile,g' \
	-e 's,drivers/media/dvb/firewire/firedtv-avc\.c,drivers/media/firewire/firedtv-avc\.c,g' \
	-e 's,drivers/media/dvb/firewire/firedtv-ci\.c,drivers/media/firewire/firedtv-ci\.c,g' \
	-e 's,drivers/media/dvb/firewire/firedtv-dvb\.c,drivers/media/firewire/firedtv-dvb\.c,g' \
	-e 's,drivers/media/dvb/firewire/firedtv-fe\.c,drivers/media/firewire/firedtv-fe\.c,g' \
	-e 's,drivers/media/dvb/firewire/firedtv-fw\.c,drivers/media/firewire/firedtv-fw\.c,g' \
	-e 's,drivers/media/dvb/firewire/firedtv-rc\.c,drivers/media/firewire/firedtv-rc\.c,g' \
	-e 's,drivers/media/dvb/firewire/firedtv\.h,drivers/media/firewire/firedtv\.h,g' \
	-e 's,drivers/media/video/adp1653\.c,drivers/media/i2c/adp1653\.c,g' \
	-e 's,drivers/media/video/adv7170\.c,drivers/media/i2c/adv7170\.c,g' \
	-e 's,drivers/media/video/adv7175\.c,drivers/media/i2c/adv7175\.c,g' \
	-e 's,drivers/media/video/adv7180\.c,drivers/media/i2c/adv7180\.c,g' \
	-e 's,drivers/media/video/adv7183\.c,drivers/media/i2c/adv7183\.c,g' \
	-e 's,drivers/media/video/adv7183_regs\.h,drivers/media/i2c/adv7183_regs\.h,g' \
	-e 's,drivers/media/video/adv7343\.c,drivers/media/i2c/adv7343\.c,g' \
	-e 's,drivers/media/video/adv7343_regs\.h,drivers/media/i2c/adv7343_regs\.h,g' \
	-e 's,drivers/media/video/adv7393\.c,drivers/media/i2c/adv7393\.c,g' \
	-e 's,drivers/media/video/adv7393_regs\.h,drivers/media/i2c/adv7393_regs\.h,g' \
	-e 's,drivers/media/video/ak881x\.c,drivers/media/i2c/ak881x\.c,g' \
	-e 's,drivers/media/video/aptina-pll\.c,drivers/media/i2c/aptina-pll\.c,g' \
	-e 's,drivers/media/video/aptina-pll\.h,drivers/media/i2c/aptina-pll\.h,g' \
	-e 's,drivers/media/video/as3645a\.c,drivers/media/i2c/as3645a\.c,g' \
	-e 's,drivers/media/video/bt819\.c,drivers/media/i2c/bt819\.c,g' \
	-e 's,drivers/media/video/bt856\.c,drivers/media/i2c/bt856\.c,g' \
	-e 's,drivers/media/video/bt866\.c,drivers/media/i2c/bt866\.c,g' \
	-e 's,drivers/media/video/btcx-risc\.c,drivers/media/i2c/btcx-risc\.c,g' \
	-e 's,drivers/media/video/btcx-risc\.h,drivers/media/i2c/btcx-risc\.h,g' \
	-e 's,drivers/media/video/cs5345\.c,drivers/media/i2c/cs5345\.c,g' \
	-e 's,drivers/media/video/cs53l32a\.c,drivers/media/i2c/cs53l32a\.c,g' \
	-e 's,drivers/media/video/cx2341x\.c,drivers/media/i2c/cx2341x\.c,g' \
	-e 's,drivers/media/video/cx25840/Kconfig,drivers/media/i2c/cx25840/Kconfig,g' \
	-e 's,drivers/media/video/cx25840/Makefile,drivers/media/i2c/cx25840/Makefile,g' \
	-e 's,drivers/media/video/cx25840/cx25840-audio\.c,drivers/media/i2c/cx25840/cx25840-audio\.c,g' \
	-e 's,drivers/media/video/cx25840/cx25840-core\.c,drivers/media/i2c/cx25840/cx25840-core\.c,g' \
	-e 's,drivers/media/video/cx25840/cx25840-core\.h,drivers/media/i2c/cx25840/cx25840-core\.h,g' \
	-e 's,drivers/media/video/cx25840/cx25840-firmware\.c,drivers/media/i2c/cx25840/cx25840-firmware\.c,g' \
	-e 's,drivers/media/video/cx25840/cx25840-ir\.c,drivers/media/i2c/cx25840/cx25840-ir\.c,g' \
	-e 's,drivers/media/video/cx25840/cx25840-vbi\.c,drivers/media/i2c/cx25840/cx25840-vbi\.c,g' \
	-e 's,drivers/media/video/ir-kbd-i2c\.c,drivers/media/i2c/ir-kbd-i2c\.c,g' \
	-e 's,drivers/media/video/ks0127\.c,drivers/media/i2c/ks0127\.c,g' \
	-e 's,drivers/media/video/ks0127\.h,drivers/media/i2c/ks0127\.h,g' \
	-e 's,drivers/media/video/m52790\.c,drivers/media/i2c/m52790\.c,g' \
	-e 's,drivers/media/video/m5mols/Kconfig,drivers/media/i2c/m5mols/Kconfig,g' \
	-e 's,drivers/media/video/m5mols/Makefile,drivers/media/i2c/m5mols/Makefile,g' \
	-e 's,drivers/media/video/m5mols/m5mols\.h,drivers/media/i2c/m5mols/m5mols\.h,g' \
	-e 's,drivers/media/video/m5mols/m5mols_capture\.c,drivers/media/i2c/m5mols/m5mols_capture\.c,g' \
	-e 's,drivers/media/video/m5mols/m5mols_controls\.c,drivers/media/i2c/m5mols/m5mols_controls\.c,g' \
	-e 's,drivers/media/video/m5mols/m5mols_core\.c,drivers/media/i2c/m5mols/m5mols_core\.c,g' \
	-e 's,drivers/media/video/m5mols/m5mols_reg\.h,drivers/media/i2c/m5mols/m5mols_reg\.h,g' \
	-e 's,drivers/media/video/msp3400-driver\.c,drivers/media/i2c/msp3400-driver\.c,g' \
	-e 's,drivers/media/video/msp3400-driver\.h,drivers/media/i2c/msp3400-driver\.h,g' \
	-e 's,drivers/media/video/msp3400-kthreads\.c,drivers/media/i2c/msp3400-kthreads\.c,g' \
	-e 's,drivers/media/video/mt9m032\.c,drivers/media/i2c/mt9m032\.c,g' \
	-e 's,drivers/media/video/mt9p031\.c,drivers/media/i2c/mt9p031\.c,g' \
	-e 's,drivers/media/video/mt9t001\.c,drivers/media/i2c/mt9t001\.c,g' \
	-e 's,drivers/media/video/mt9v011\.c,drivers/media/i2c/mt9v011\.c,g' \
	-e 's,drivers/media/video/mt9v032\.c,drivers/media/i2c/mt9v032\.c,g' \
	-e 's,drivers/media/video/noon010pc30\.c,drivers/media/i2c/noon010pc30\.c,g' \
	-e 's,drivers/media/video/ov7670\.c,drivers/media/i2c/ov7670\.c,g' \
	-e 's,drivers/media/video/s5k6aa\.c,drivers/media/i2c/s5k6aa\.c,g' \
	-e 's,drivers/media/video/saa6588\.c,drivers/media/i2c/saa6588\.c,g' \
	-e 's,drivers/media/video/saa7110\.c,drivers/media/i2c/saa7110\.c,g' \
	-e 's,drivers/media/video/saa7115\.c,drivers/media/i2c/saa7115\.c,g' \
	-e 's,drivers/media/video/saa711x_regs\.h,drivers/media/i2c/saa711x_regs\.h,g' \
	-e 's,drivers/media/video/saa7127\.c,drivers/media/i2c/saa7127\.c,g' \
	-e 's,drivers/media/video/saa717x\.c,drivers/media/i2c/saa717x\.c,g' \
	-e 's,drivers/media/video/saa7185\.c,drivers/media/i2c/saa7185\.c,g' \
	-e 's,drivers/media/video/saa7191\.c,drivers/media/i2c/saa7191\.c,g' \
	-e 's,drivers/media/video/saa7191\.h,drivers/media/i2c/saa7191\.h,g' \
	-e 's,drivers/media/video/smiapp-pll\.c,drivers/media/i2c/smiapp-pll\.c,g' \
	-e 's,drivers/media/video/smiapp-pll\.h,drivers/media/i2c/smiapp-pll\.h,g' \
	-e 's,drivers/media/video/smiapp/Kconfig,drivers/media/i2c/smiapp/Kconfig,g' \
	-e 's,drivers/media/video/smiapp/Makefile,drivers/media/i2c/smiapp/Makefile,g' \
	-e 's,drivers/media/video/smiapp/smiapp-core\.c,drivers/media/i2c/smiapp/smiapp-core\.c,g' \
	-e 's,drivers/media/video/smiapp/smiapp-limits\.c,drivers/media/i2c/smiapp/smiapp-limits\.c,g' \
	-e 's,drivers/media/video/smiapp/smiapp-limits\.h,drivers/media/i2c/smiapp/smiapp-limits\.h,g' \
	-e 's,drivers/media/video/smiapp/smiapp-quirk\.c,drivers/media/i2c/smiapp/smiapp-quirk\.c,g' \
	-e 's,drivers/media/video/smiapp/smiapp-quirk\.h,drivers/media/i2c/smiapp/smiapp-quirk\.h,g' \
	-e 's,drivers/media/video/smiapp/smiapp-reg-defs\.h,drivers/media/i2c/smiapp/smiapp-reg-defs\.h,g' \
	-e 's,drivers/media/video/smiapp/smiapp-reg\.h,drivers/media/i2c/smiapp/smiapp-reg\.h,g' \
	-e 's,drivers/media/video/smiapp/smiapp-regs\.c,drivers/media/i2c/smiapp/smiapp-regs\.c,g' \
	-e 's,drivers/media/video/smiapp/smiapp-regs\.h,drivers/media/i2c/smiapp/smiapp-regs\.h,g' \
	-e 's,drivers/media/video/smiapp/smiapp\.h,drivers/media/i2c/smiapp/smiapp\.h,g' \
	-e 's,drivers/media/video/imx074\.c,drivers/media/i2c/soc_camera/imx074\.c,g' \
	-e 's,drivers/media/video/mt9m001\.c,drivers/media/i2c/soc_camera/mt9m001\.c,g' \
	-e 's,drivers/media/video/mt9m111\.c,drivers/media/i2c/soc_camera/mt9m111\.c,g' \
	-e 's,drivers/media/video/mt9t031\.c,drivers/media/i2c/soc_camera/mt9t031\.c,g' \
	-e 's,drivers/media/video/mt9t112\.c,drivers/media/i2c/soc_camera/mt9t112\.c,g' \
	-e 's,drivers/media/video/mt9v022\.c,drivers/media/i2c/soc_camera/mt9v022\.c,g' \
	-e 's,drivers/media/video/ov2640\.c,drivers/media/i2c/soc_camera/ov2640\.c,g' \
	-e 's,drivers/media/video/ov5642\.c,drivers/media/i2c/soc_camera/ov5642\.c,g' \
	-e 's,drivers/media/video/ov6650\.c,drivers/media/i2c/soc_camera/ov6650\.c,g' \
	-e 's,drivers/media/video/ov772x\.c,drivers/media/i2c/soc_camera/ov772x\.c,g' \
	-e 's,drivers/media/video/ov9640\.c,drivers/media/i2c/soc_camera/ov9640\.c,g' \
	-e 's,drivers/media/video/ov9640\.h,drivers/media/i2c/soc_camera/ov9640\.h,g' \
	-e 's,drivers/media/video/ov9740\.c,drivers/media/i2c/soc_camera/ov9740\.c,g' \
	-e 's,drivers/media/video/rj54n1cb0c\.c,drivers/media/i2c/soc_camera/rj54n1cb0c\.c,g' \
	-e 's,drivers/media/video/tw9910\.c,drivers/media/i2c/soc_camera/tw9910\.c,g' \
	-e 's,drivers/media/video/sr030pc30\.c,drivers/media/i2c/sr030pc30\.c,g' \
	-e 's,drivers/media/video/tcm825x\.c,drivers/media/i2c/tcm825x\.c,g' \
	-e 's,drivers/media/video/tcm825x\.h,drivers/media/i2c/tcm825x\.h,g' \
	-e 's,drivers/media/video/tda7432\.c,drivers/media/i2c/tda7432\.c,g' \
	-e 's,drivers/media/video/tda9840\.c,drivers/media/i2c/tda9840\.c,g' \
	-e 's,drivers/media/video/tea6415c\.c,drivers/media/i2c/tea6415c\.c,g' \
	-e 's,drivers/media/video/tea6415c\.h,drivers/media/i2c/tea6415c\.h,g' \
	-e 's,drivers/media/video/tea6420\.c,drivers/media/i2c/tea6420\.c,g' \
	-e 's,drivers/media/video/tea6420\.h,drivers/media/i2c/tea6420\.h,g' \
	-e 's,drivers/media/video/ths7303\.c,drivers/media/i2c/ths7303\.c,g' \
	-e 's,drivers/media/video/tlv320aic23b\.c,drivers/media/i2c/tlv320aic23b\.c,g' \
	-e 's,drivers/media/video/tvaudio\.c,drivers/media/i2c/tvaudio\.c,g' \
	-e 's,drivers/media/video/tveeprom\.c,drivers/media/i2c/tveeprom\.c,g' \
	-e 's,drivers/media/video/tvp514x\.c,drivers/media/i2c/tvp514x\.c,g' \
	-e 's,drivers/media/video/tvp514x_regs\.h,drivers/media/i2c/tvp514x_regs\.h,g' \
	-e 's,drivers/media/video/tvp5150\.c,drivers/media/i2c/tvp5150\.c,g' \
	-e 's,drivers/media/video/tvp5150_reg\.h,drivers/media/i2c/tvp5150_reg\.h,g' \
	-e 's,drivers/media/video/tvp7002\.c,drivers/media/i2c/tvp7002\.c,g' \
	-e 's,drivers/media/video/tvp7002_reg\.h,drivers/media/i2c/tvp7002_reg\.h,g' \
	-e 's,drivers/media/video/upd64031a\.c,drivers/media/i2c/upd64031a\.c,g' \
	-e 's,drivers/media/video/upd64083\.c,drivers/media/i2c/upd64083\.c,g' \
	-e 's,drivers/media/video/vp27smpx\.c,drivers/media/i2c/vp27smpx\.c,g' \
	-e 's,drivers/media/video/vpx3220\.c,drivers/media/i2c/vpx3220\.c,g' \
	-e 's,drivers/media/video/vs6624\.c,drivers/media/i2c/vs6624\.c,g' \
	-e 's,drivers/media/video/vs6624_regs\.h,drivers/media/i2c/vs6624_regs\.h,g' \
	-e 's,drivers/media/video/wm8739\.c,drivers/media/i2c/wm8739\.c,g' \
	-e 's,drivers/media/video/wm8775\.c,drivers/media/i2c/wm8775\.c,g' \
	-e 's,drivers/media/dvb/siano/smssdio\.c,drivers/media/mmc/siano/smssdio\.c,g' \
	-e 's,drivers/media/video/bw-qcam\.c,drivers/media/parport/bw-qcam\.c,g' \
	-e 's,drivers/media/video/c-qcam\.c,drivers/media/parport/c-qcam\.c,g' \
	-e 's,drivers/media/video/pms\.c,drivers/media/parport/pms\.c,g' \
	-e 's,drivers/media/video/w9966\.c,drivers/media/parport/w9966\.c,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop-dma\.c,drivers/media/pci/b2c2/flexcop-dma\.c,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop-pci\.c,drivers/media/pci/b2c2/flexcop-pci\.c,g' \
	-e 's,drivers/media/dvb/bt8xx/Kconfig,drivers/media/pci/bt8xx/Kconfig,g' \
	-e 's,drivers/media/video/bt8xx/Makefile,drivers/media/pci/bt8xx/Makefile,g' \
	-e 's,drivers/media/video/bt8xx/bt848\.h,drivers/media/pci/bt8xx/bt848\.h,g' \
	-e 's,drivers/media/dvb/bt8xx/bt878\.c,drivers/media/pci/bt8xx/bt878\.c,g' \
	-e 's,drivers/media/dvb/bt8xx/bt878\.h,drivers/media/pci/bt8xx/bt878\.h,g' \
	-e 's,drivers/media/video/bt8xx/bttv-audio-hook\.c,drivers/media/pci/bt8xx/bttv-audio-hook\.c,g' \
	-e 's,drivers/media/video/bt8xx/bttv-audio-hook\.h,drivers/media/pci/bt8xx/bttv-audio-hook\.h,g' \
	-e 's,drivers/media/video/bt8xx/bttv-cards\.c,drivers/media/pci/bt8xx/bttv-cards\.c,g' \
	-e 's,drivers/media/video/bt8xx/bttv-driver\.c,drivers/media/pci/bt8xx/bttv-driver\.c,g' \
	-e 's,drivers/media/video/bt8xx/bttv-gpio\.c,drivers/media/pci/bt8xx/bttv-gpio\.c,g' \
	-e 's,drivers/media/video/bt8xx/bttv-i2c\.c,drivers/media/pci/bt8xx/bttv-i2c\.c,g' \
	-e 's,drivers/media/video/bt8xx/bttv-if\.c,drivers/media/pci/bt8xx/bttv-if\.c,g' \
	-e 's,drivers/media/video/bt8xx/bttv-input\.c,drivers/media/pci/bt8xx/bttv-input\.c,g' \
	-e 's,drivers/media/video/bt8xx/bttv-risc\.c,drivers/media/pci/bt8xx/bttv-risc\.c,g' \
	-e 's,drivers/media/video/bt8xx/bttv-vbi\.c,drivers/media/pci/bt8xx/bttv-vbi\.c,g' \
	-e 's,drivers/media/video/bt8xx/bttv\.h,drivers/media/pci/bt8xx/bttv\.h,g' \
	-e 's,drivers/media/video/bt8xx/bttvp\.h,drivers/media/pci/bt8xx/bttvp\.h,g' \
	-e 's,drivers/media/dvb/bt8xx/dst\.c,drivers/media/pci/bt8xx/dst\.c,g' \
	-e 's,drivers/media/dvb/bt8xx/dst_ca\.c,drivers/media/pci/bt8xx/dst_ca\.c,g' \
	-e 's,drivers/media/dvb/bt8xx/dst_ca\.h,drivers/media/pci/bt8xx/dst_ca\.h,g' \
	-e 's,drivers/media/dvb/bt8xx/dst_common\.h,drivers/media/pci/bt8xx/dst_common\.h,g' \
	-e 's,drivers/media/dvb/bt8xx/dst_priv\.h,drivers/media/pci/bt8xx/dst_priv\.h,g' \
	-e 's,drivers/media/dvb/bt8xx/dvb-bt8xx\.c,drivers/media/pci/bt8xx/dvb-bt8xx\.c,g' \
	-e 's,drivers/media/dvb/bt8xx/dvb-bt8xx\.h,drivers/media/pci/bt8xx/dvb-bt8xx\.h,g' \
	-e 's,drivers/media/video/cx18/Kconfig,drivers/media/pci/cx18/Kconfig,g' \
	-e 's,drivers/media/video/cx18/Makefile,drivers/media/pci/cx18/Makefile,g' \
	-e 's,drivers/media/video/cx18/cx18-alsa-main\.c,drivers/media/pci/cx18/cx18-alsa-main\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-alsa-mixer\.c,drivers/media/pci/cx18/cx18-alsa-mixer\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-alsa-mixer\.h,drivers/media/pci/cx18/cx18-alsa-mixer\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-alsa-pcm\.c,drivers/media/pci/cx18/cx18-alsa-pcm\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-alsa-pcm\.h,drivers/media/pci/cx18/cx18-alsa-pcm\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-alsa\.h,drivers/media/pci/cx18/cx18-alsa\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-audio\.c,drivers/media/pci/cx18/cx18-audio\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-audio\.h,drivers/media/pci/cx18/cx18-audio\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-av-audio\.c,drivers/media/pci/cx18/cx18-av-audio\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-av-core\.c,drivers/media/pci/cx18/cx18-av-core\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-av-core\.h,drivers/media/pci/cx18/cx18-av-core\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-av-firmware\.c,drivers/media/pci/cx18/cx18-av-firmware\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-av-vbi\.c,drivers/media/pci/cx18/cx18-av-vbi\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-cards\.c,drivers/media/pci/cx18/cx18-cards\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-cards\.h,drivers/media/pci/cx18/cx18-cards\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-controls\.c,drivers/media/pci/cx18/cx18-controls\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-controls\.h,drivers/media/pci/cx18/cx18-controls\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-driver\.c,drivers/media/pci/cx18/cx18-driver\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-driver\.h,drivers/media/pci/cx18/cx18-driver\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-dvb\.c,drivers/media/pci/cx18/cx18-dvb\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-dvb\.h,drivers/media/pci/cx18/cx18-dvb\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-fileops\.c,drivers/media/pci/cx18/cx18-fileops\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-fileops\.h,drivers/media/pci/cx18/cx18-fileops\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-firmware\.c,drivers/media/pci/cx18/cx18-firmware\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-firmware\.h,drivers/media/pci/cx18/cx18-firmware\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-gpio\.c,drivers/media/pci/cx18/cx18-gpio\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-gpio\.h,drivers/media/pci/cx18/cx18-gpio\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-i2c\.c,drivers/media/pci/cx18/cx18-i2c\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-i2c\.h,drivers/media/pci/cx18/cx18-i2c\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-io\.c,drivers/media/pci/cx18/cx18-io\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-io\.h,drivers/media/pci/cx18/cx18-io\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-ioctl\.c,drivers/media/pci/cx18/cx18-ioctl\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-ioctl\.h,drivers/media/pci/cx18/cx18-ioctl\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-irq\.c,drivers/media/pci/cx18/cx18-irq\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-irq\.h,drivers/media/pci/cx18/cx18-irq\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-mailbox\.c,drivers/media/pci/cx18/cx18-mailbox\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-mailbox\.h,drivers/media/pci/cx18/cx18-mailbox\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-queue\.c,drivers/media/pci/cx18/cx18-queue\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-queue\.h,drivers/media/pci/cx18/cx18-queue\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-scb\.c,drivers/media/pci/cx18/cx18-scb\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-scb\.h,drivers/media/pci/cx18/cx18-scb\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-streams\.c,drivers/media/pci/cx18/cx18-streams\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-streams\.h,drivers/media/pci/cx18/cx18-streams\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-vbi\.c,drivers/media/pci/cx18/cx18-vbi\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-vbi\.h,drivers/media/pci/cx18/cx18-vbi\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-version\.h,drivers/media/pci/cx18/cx18-version\.h,g' \
	-e 's,drivers/media/video/cx18/cx18-video\.c,drivers/media/pci/cx18/cx18-video\.c,g' \
	-e 's,drivers/media/video/cx18/cx18-video\.h,drivers/media/pci/cx18/cx18-video\.h,g' \
	-e 's,drivers/media/video/cx18/cx23418\.h,drivers/media/pci/cx18/cx23418\.h,g' \
	-e 's,drivers/media/video/cx23885/Kconfig,drivers/media/pci/cx23885/Kconfig,g' \
	-e 's,drivers/media/video/cx23885/Makefile,drivers/media/pci/cx23885/Makefile,g' \
	-e 's,drivers/media/video/cx23885/altera-ci\.c,drivers/media/pci/cx23885/altera-ci\.c,g' \
	-e 's,drivers/media/video/cx23885/altera-ci\.h,drivers/media/pci/cx23885/altera-ci\.h,g' \
	-e 's,drivers/media/video/cx23885/cimax2\.c,drivers/media/pci/cx23885/cimax2\.c,g' \
	-e 's,drivers/media/video/cx23885/cimax2\.h,drivers/media/pci/cx23885/cimax2\.h,g' \
	-e 's,drivers/media/video/cx23885/cx23885-417\.c,drivers/media/pci/cx23885/cx23885-417\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885-alsa\.c,drivers/media/pci/cx23885/cx23885-alsa\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885-av\.c,drivers/media/pci/cx23885/cx23885-av\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885-av\.h,drivers/media/pci/cx23885/cx23885-av\.h,g' \
	-e 's,drivers/media/video/cx23885/cx23885-cards\.c,drivers/media/pci/cx23885/cx23885-cards\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885-core\.c,drivers/media/pci/cx23885/cx23885-core\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885-dvb\.c,drivers/media/pci/cx23885/cx23885-dvb\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885-f300\.c,drivers/media/pci/cx23885/cx23885-f300\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885-f300\.h,drivers/media/pci/cx23885/cx23885-f300\.h,g' \
	-e 's,drivers/media/video/cx23885/cx23885-i2c\.c,drivers/media/pci/cx23885/cx23885-i2c\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885-input\.c,drivers/media/pci/cx23885/cx23885-input\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885-input\.h,drivers/media/pci/cx23885/cx23885-input\.h,g' \
	-e 's,drivers/media/video/cx23885/cx23885-ioctl\.c,drivers/media/pci/cx23885/cx23885-ioctl\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885-ioctl\.h,drivers/media/pci/cx23885/cx23885-ioctl\.h,g' \
	-e 's,drivers/media/video/cx23885/cx23885-ir\.c,drivers/media/pci/cx23885/cx23885-ir\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885-ir\.h,drivers/media/pci/cx23885/cx23885-ir\.h,g' \
	-e 's,drivers/media/video/cx23885/cx23885-reg\.h,drivers/media/pci/cx23885/cx23885-reg\.h,g' \
	-e 's,drivers/media/video/cx23885/cx23885-vbi\.c,drivers/media/pci/cx23885/cx23885-vbi\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885-video\.c,drivers/media/pci/cx23885/cx23885-video\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23885\.h,drivers/media/pci/cx23885/cx23885\.h,g' \
	-e 's,drivers/media/video/cx23885/cx23888-ir\.c,drivers/media/pci/cx23885/cx23888-ir\.c,g' \
	-e 's,drivers/media/video/cx23885/cx23888-ir\.h,drivers/media/pci/cx23885/cx23888-ir\.h,g' \
	-e 's,drivers/media/video/cx23885/netup-eeprom\.c,drivers/media/pci/cx23885/netup-eeprom\.c,g' \
	-e 's,drivers/media/video/cx23885/netup-eeprom\.h,drivers/media/pci/cx23885/netup-eeprom\.h,g' \
	-e 's,drivers/media/video/cx23885/netup-init\.c,drivers/media/pci/cx23885/netup-init\.c,g' \
	-e 's,drivers/media/video/cx23885/netup-init\.h,drivers/media/pci/cx23885/netup-init\.h,g' \
	-e 's,drivers/media/video/cx25821/Kconfig,drivers/media/pci/cx25821/Kconfig,g' \
	-e 's,drivers/media/video/cx25821/Makefile,drivers/media/pci/cx25821/Makefile,g' \
	-e 's,drivers/media/video/cx25821/cx25821-alsa\.c,drivers/media/pci/cx25821/cx25821-alsa\.c,g' \
	-e 's,drivers/media/video/cx25821/cx25821-audio-upstream\.c,drivers/media/pci/cx25821/cx25821-audio-upstream\.c,g' \
	-e 's,drivers/media/video/cx25821/cx25821-audio-upstream\.h,drivers/media/pci/cx25821/cx25821-audio-upstream\.h,g' \
	-e 's,drivers/media/video/cx25821/cx25821-audio\.h,drivers/media/pci/cx25821/cx25821-audio\.h,g' \
	-e 's,drivers/media/video/cx25821/cx25821-biffuncs\.h,drivers/media/pci/cx25821/cx25821-biffuncs\.h,g' \
	-e 's,drivers/media/video/cx25821/cx25821-cards\.c,drivers/media/pci/cx25821/cx25821-cards\.c,g' \
	-e 's,drivers/media/video/cx25821/cx25821-core\.c,drivers/media/pci/cx25821/cx25821-core\.c,g' \
	-e 's,drivers/media/video/cx25821/cx25821-gpio\.c,drivers/media/pci/cx25821/cx25821-gpio\.c,g' \
	-e 's,drivers/media/video/cx25821/cx25821-i2c\.c,drivers/media/pci/cx25821/cx25821-i2c\.c,g' \
	-e 's,drivers/media/video/cx25821/cx25821-medusa-defines\.h,drivers/media/pci/cx25821/cx25821-medusa-defines\.h,g' \
	-e 's,drivers/media/video/cx25821/cx25821-medusa-reg\.h,drivers/media/pci/cx25821/cx25821-medusa-reg\.h,g' \
	-e 's,drivers/media/video/cx25821/cx25821-medusa-video\.c,drivers/media/pci/cx25821/cx25821-medusa-video\.c,g' \
	-e 's,drivers/media/video/cx25821/cx25821-medusa-video\.h,drivers/media/pci/cx25821/cx25821-medusa-video\.h,g' \
	-e 's,drivers/media/video/cx25821/cx25821-reg\.h,drivers/media/pci/cx25821/cx25821-reg\.h,g' \
	-e 's,drivers/media/video/cx25821/cx25821-sram\.h,drivers/media/pci/cx25821/cx25821-sram\.h,g' \
	-e 's,drivers/media/video/cx25821/cx25821-video-upstream-ch2\.c,drivers/media/pci/cx25821/cx25821-video-upstream-ch2\.c,g' \
	-e 's,drivers/media/video/cx25821/cx25821-video-upstream-ch2\.h,drivers/media/pci/cx25821/cx25821-video-upstream-ch2\.h,g' \
	-e 's,drivers/media/video/cx25821/cx25821-video-upstream\.c,drivers/media/pci/cx25821/cx25821-video-upstream\.c,g' \
	-e 's,drivers/media/video/cx25821/cx25821-video-upstream\.h,drivers/media/pci/cx25821/cx25821-video-upstream\.h,g' \
	-e 's,drivers/media/video/cx25821/cx25821-video\.c,drivers/media/pci/cx25821/cx25821-video\.c,g' \
	-e 's,drivers/media/video/cx25821/cx25821-video\.h,drivers/media/pci/cx25821/cx25821-video\.h,g' \
	-e 's,drivers/media/video/cx25821/cx25821\.h,drivers/media/pci/cx25821/cx25821\.h,g' \
	-e 's,drivers/media/video/cx88/Kconfig,drivers/media/pci/cx88/Kconfig,g' \
	-e 's,drivers/media/video/cx88/Makefile,drivers/media/pci/cx88/Makefile,g' \
	-e 's,drivers/media/video/cx88/cx88-alsa\.c,drivers/media/pci/cx88/cx88-alsa\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-blackbird\.c,drivers/media/pci/cx88/cx88-blackbird\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-cards\.c,drivers/media/pci/cx88/cx88-cards\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-core\.c,drivers/media/pci/cx88/cx88-core\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-dsp\.c,drivers/media/pci/cx88/cx88-dsp\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-dvb\.c,drivers/media/pci/cx88/cx88-dvb\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-i2c\.c,drivers/media/pci/cx88/cx88-i2c\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-input\.c,drivers/media/pci/cx88/cx88-input\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-mpeg\.c,drivers/media/pci/cx88/cx88-mpeg\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-reg\.h,drivers/media/pci/cx88/cx88-reg\.h,g' \
	-e 's,drivers/media/video/cx88/cx88-tvaudio\.c,drivers/media/pci/cx88/cx88-tvaudio\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-vbi\.c,drivers/media/pci/cx88/cx88-vbi\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-video\.c,drivers/media/pci/cx88/cx88-video\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-vp3054-i2c\.c,drivers/media/pci/cx88/cx88-vp3054-i2c\.c,g' \
	-e 's,drivers/media/video/cx88/cx88-vp3054-i2c\.h,drivers/media/pci/cx88/cx88-vp3054-i2c\.h,g' \
	-e 's,drivers/media/video/cx88/cx88\.h,drivers/media/pci/cx88/cx88\.h,g' \
	-e 's,drivers/media/dvb/ddbridge/Kconfig,drivers/media/pci/ddbridge/Kconfig,g' \
	-e 's,drivers/media/dvb/ddbridge/Makefile,drivers/media/pci/ddbridge/Makefile,g' \
	-e 's,drivers/media/dvb/ddbridge/ddbridge-core\.c,drivers/media/pci/ddbridge/ddbridge-core\.c,g' \
	-e 's,drivers/media/dvb/ddbridge/ddbridge-regs\.h,drivers/media/pci/ddbridge/ddbridge-regs\.h,g' \
	-e 's,drivers/media/dvb/ddbridge/ddbridge\.h,drivers/media/pci/ddbridge/ddbridge\.h,g' \
	-e 's,drivers/media/dvb/dm1105/Kconfig,drivers/media/pci/dm1105/Kconfig,g' \
	-e 's,drivers/media/dvb/dm1105/Makefile,drivers/media/pci/dm1105/Makefile,g' \
	-e 's,drivers/media/dvb/dm1105/dm1105\.c,drivers/media/pci/dm1105/dm1105\.c,g' \
	-e 's,drivers/media/video/ivtv/Kconfig,drivers/media/pci/ivtv/Kconfig,g' \
	-e 's,drivers/media/video/ivtv/Makefile,drivers/media/pci/ivtv/Makefile,g' \
	-e 's,drivers/media/video/ivtv/ivtv-cards\.c,drivers/media/pci/ivtv/ivtv-cards\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-cards\.h,drivers/media/pci/ivtv/ivtv-cards\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-controls\.c,drivers/media/pci/ivtv/ivtv-controls\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-controls\.h,drivers/media/pci/ivtv/ivtv-controls\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-driver\.c,drivers/media/pci/ivtv/ivtv-driver\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-driver\.h,drivers/media/pci/ivtv/ivtv-driver\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-fileops\.c,drivers/media/pci/ivtv/ivtv-fileops\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-fileops\.h,drivers/media/pci/ivtv/ivtv-fileops\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-firmware\.c,drivers/media/pci/ivtv/ivtv-firmware\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-firmware\.h,drivers/media/pci/ivtv/ivtv-firmware\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-gpio\.c,drivers/media/pci/ivtv/ivtv-gpio\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-gpio\.h,drivers/media/pci/ivtv/ivtv-gpio\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-i2c\.c,drivers/media/pci/ivtv/ivtv-i2c\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-i2c\.h,drivers/media/pci/ivtv/ivtv-i2c\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-ioctl\.c,drivers/media/pci/ivtv/ivtv-ioctl\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-ioctl\.h,drivers/media/pci/ivtv/ivtv-ioctl\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-irq\.c,drivers/media/pci/ivtv/ivtv-irq\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-irq\.h,drivers/media/pci/ivtv/ivtv-irq\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-mailbox\.c,drivers/media/pci/ivtv/ivtv-mailbox\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-mailbox\.h,drivers/media/pci/ivtv/ivtv-mailbox\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-queue\.c,drivers/media/pci/ivtv/ivtv-queue\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-queue\.h,drivers/media/pci/ivtv/ivtv-queue\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-routing\.c,drivers/media/pci/ivtv/ivtv-routing\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-routing\.h,drivers/media/pci/ivtv/ivtv-routing\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-streams\.c,drivers/media/pci/ivtv/ivtv-streams\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-streams\.h,drivers/media/pci/ivtv/ivtv-streams\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-udma\.c,drivers/media/pci/ivtv/ivtv-udma\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-udma\.h,drivers/media/pci/ivtv/ivtv-udma\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-vbi\.c,drivers/media/pci/ivtv/ivtv-vbi\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-vbi\.h,drivers/media/pci/ivtv/ivtv-vbi\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-version\.h,drivers/media/pci/ivtv/ivtv-version\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtv-yuv\.c,drivers/media/pci/ivtv/ivtv-yuv\.c,g' \
	-e 's,drivers/media/video/ivtv/ivtv-yuv\.h,drivers/media/pci/ivtv/ivtv-yuv\.h,g' \
	-e 's,drivers/media/video/ivtv/ivtvfb\.c,drivers/media/pci/ivtv/ivtvfb\.c,g' \
	-e 's,drivers/media/dvb/mantis/Kconfig,drivers/media/pci/mantis/Kconfig,g' \
	-e 's,drivers/media/dvb/mantis/Makefile,drivers/media/pci/mantis/Makefile,g' \
	-e 's,drivers/media/dvb/mantis/hopper_cards\.c,drivers/media/pci/mantis/hopper_cards\.c,g' \
	-e 's,drivers/media/dvb/mantis/hopper_vp3028\.c,drivers/media/pci/mantis/hopper_vp3028\.c,g' \
	-e 's,drivers/media/dvb/mantis/hopper_vp3028\.h,drivers/media/pci/mantis/hopper_vp3028\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_ca\.c,drivers/media/pci/mantis/mantis_ca\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_ca\.h,drivers/media/pci/mantis/mantis_ca\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_cards\.c,drivers/media/pci/mantis/mantis_cards\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_common\.h,drivers/media/pci/mantis/mantis_common\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_core\.c,drivers/media/pci/mantis/mantis_core\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_core\.h,drivers/media/pci/mantis/mantis_core\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_dma\.c,drivers/media/pci/mantis/mantis_dma\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_dma\.h,drivers/media/pci/mantis/mantis_dma\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_dvb\.c,drivers/media/pci/mantis/mantis_dvb\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_dvb\.h,drivers/media/pci/mantis/mantis_dvb\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_evm\.c,drivers/media/pci/mantis/mantis_evm\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_hif\.c,drivers/media/pci/mantis/mantis_hif\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_hif\.h,drivers/media/pci/mantis/mantis_hif\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_i2c\.c,drivers/media/pci/mantis/mantis_i2c\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_i2c\.h,drivers/media/pci/mantis/mantis_i2c\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_input\.c,drivers/media/pci/mantis/mantis_input\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_ioc\.c,drivers/media/pci/mantis/mantis_ioc\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_ioc\.h,drivers/media/pci/mantis/mantis_ioc\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_link\.h,drivers/media/pci/mantis/mantis_link\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_pci\.c,drivers/media/pci/mantis/mantis_pci\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_pci\.h,drivers/media/pci/mantis/mantis_pci\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_pcmcia\.c,drivers/media/pci/mantis/mantis_pcmcia\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_reg\.h,drivers/media/pci/mantis/mantis_reg\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_uart\.c,drivers/media/pci/mantis/mantis_uart\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_uart\.h,drivers/media/pci/mantis/mantis_uart\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp1033\.c,drivers/media/pci/mantis/mantis_vp1033\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp1033\.h,drivers/media/pci/mantis/mantis_vp1033\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp1034\.c,drivers/media/pci/mantis/mantis_vp1034\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp1034\.h,drivers/media/pci/mantis/mantis_vp1034\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp1041\.c,drivers/media/pci/mantis/mantis_vp1041\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp1041\.h,drivers/media/pci/mantis/mantis_vp1041\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp2033\.c,drivers/media/pci/mantis/mantis_vp2033\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp2033\.h,drivers/media/pci/mantis/mantis_vp2033\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp2040\.c,drivers/media/pci/mantis/mantis_vp2040\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp2040\.h,drivers/media/pci/mantis/mantis_vp2040\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp3028\.c,drivers/media/pci/mantis/mantis_vp3028\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp3028\.h,drivers/media/pci/mantis/mantis_vp3028\.h,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp3030\.c,drivers/media/pci/mantis/mantis_vp3030\.c,g' \
	-e 's,drivers/media/dvb/mantis/mantis_vp3030\.h,drivers/media/pci/mantis/mantis_vp3030\.h,g' \
	-e 's,drivers/media/video/meye\.c,drivers/media/pci/meye/meye\.c,g' \
	-e 's,drivers/media/video/meye\.h,drivers/media/pci/meye/meye\.h,g' \
	-e 's,drivers/media/dvb/ngene/Kconfig,drivers/media/pci/ngene/Kconfig,g' \
	-e 's,drivers/media/dvb/ngene/Makefile,drivers/media/pci/ngene/Makefile,g' \
	-e 's,drivers/media/dvb/ngene/ngene-cards\.c,drivers/media/pci/ngene/ngene-cards\.c,g' \
	-e 's,drivers/media/dvb/ngene/ngene-core\.c,drivers/media/pci/ngene/ngene-core\.c,g' \
	-e 's,drivers/media/dvb/ngene/ngene-dvb\.c,drivers/media/pci/ngene/ngene-dvb\.c,g' \
	-e 's,drivers/media/dvb/ngene/ngene-i2c\.c,drivers/media/pci/ngene/ngene-i2c\.c,g' \
	-e 's,drivers/media/dvb/ngene/ngene\.h,drivers/media/pci/ngene/ngene\.h,g' \
	-e 's,drivers/media/dvb/pluto2/Kconfig,drivers/media/pci/pluto2/Kconfig,g' \
	-e 's,drivers/media/dvb/pluto2/Makefile,drivers/media/pci/pluto2/Makefile,g' \
	-e 's,drivers/media/dvb/pluto2/pluto2\.c,drivers/media/pci/pluto2/pluto2\.c,g' \
	-e 's,drivers/media/dvb/pt1/Kconfig,drivers/media/pci/pt1/Kconfig,g' \
	-e 's,drivers/media/dvb/pt1/Makefile,drivers/media/pci/pt1/Makefile,g' \
	-e 's,drivers/media/dvb/pt1/pt1\.c,drivers/media/pci/pt1/pt1\.c,g' \
	-e 's,drivers/media/dvb/pt1/va1j5jf8007s\.c,drivers/media/pci/pt1/va1j5jf8007s\.c,g' \
	-e 's,drivers/media/dvb/pt1/va1j5jf8007s\.h,drivers/media/pci/pt1/va1j5jf8007s\.h,g' \
	-e 's,drivers/media/dvb/pt1/va1j5jf8007t\.c,drivers/media/pci/pt1/va1j5jf8007t\.c,g' \
	-e 's,drivers/media/dvb/pt1/va1j5jf8007t\.h,drivers/media/pci/pt1/va1j5jf8007t\.h,g' \
	-e 's,drivers/media/video/saa7134/Kconfig,drivers/media/pci/saa7134/Kconfig,g' \
	-e 's,drivers/media/video/saa7134/Makefile,drivers/media/pci/saa7134/Makefile,g' \
	-e 's,drivers/media/video/saa7134/saa6752hs\.c,drivers/media/pci/saa7134/saa6752hs\.c,g' \
	-e 's,drivers/media/video/saa7134/saa7134-alsa\.c,drivers/media/pci/saa7134/saa7134-alsa\.c,g' \
	-e 's,drivers/media/video/saa7134/saa7134-cards\.c,drivers/media/pci/saa7134/saa7134-cards\.c,g' \
	-e 's,drivers/media/video/saa7134/saa7134-core\.c,drivers/media/pci/saa7134/saa7134-core\.c,g' \
	-e 's,drivers/media/video/saa7134/saa7134-dvb\.c,drivers/media/pci/saa7134/saa7134-dvb\.c,g' \
	-e 's,drivers/media/video/saa7134/saa7134-empress\.c,drivers/media/pci/saa7134/saa7134-empress\.c,g' \
	-e 's,drivers/media/video/saa7134/saa7134-i2c\.c,drivers/media/pci/saa7134/saa7134-i2c\.c,g' \
	-e 's,drivers/media/video/saa7134/saa7134-input\.c,drivers/media/pci/saa7134/saa7134-input\.c,g' \
	-e 's,drivers/media/video/saa7134/saa7134-reg\.h,drivers/media/pci/saa7134/saa7134-reg\.h,g' \
	-e 's,drivers/media/video/saa7134/saa7134-ts\.c,drivers/media/pci/saa7134/saa7134-ts\.c,g' \
	-e 's,drivers/media/video/saa7134/saa7134-tvaudio\.c,drivers/media/pci/saa7134/saa7134-tvaudio\.c,g' \
	-e 's,drivers/media/video/saa7134/saa7134-vbi\.c,drivers/media/pci/saa7134/saa7134-vbi\.c,g' \
	-e 's,drivers/media/video/saa7134/saa7134-video\.c,drivers/media/pci/saa7134/saa7134-video\.c,g' \
	-e 's,drivers/media/video/saa7134/saa7134\.h,drivers/media/pci/saa7134/saa7134\.h,g' \
	-e 's,drivers/media/video/hexium_gemini\.c,drivers/media/pci/saa7146/hexium_gemini\.c,g' \
	-e 's,drivers/media/video/hexium_orion\.c,drivers/media/pci/saa7146/hexium_orion\.c,g' \
	-e 's,drivers/media/video/mxb\.c,drivers/media/pci/saa7146/mxb\.c,g' \
	-e 's,drivers/media/video/saa7164/Kconfig,drivers/media/pci/saa7164/Kconfig,g' \
	-e 's,drivers/media/video/saa7164/Makefile,drivers/media/pci/saa7164/Makefile,g' \
	-e 's,drivers/media/video/saa7164/saa7164-api\.c,drivers/media/pci/saa7164/saa7164-api\.c,g' \
	-e 's,drivers/media/video/saa7164/saa7164-buffer\.c,drivers/media/pci/saa7164/saa7164-buffer\.c,g' \
	-e 's,drivers/media/video/saa7164/saa7164-bus\.c,drivers/media/pci/saa7164/saa7164-bus\.c,g' \
	-e 's,drivers/media/video/saa7164/saa7164-cards\.c,drivers/media/pci/saa7164/saa7164-cards\.c,g' \
	-e 's,drivers/media/video/saa7164/saa7164-cmd\.c,drivers/media/pci/saa7164/saa7164-cmd\.c,g' \
	-e 's,drivers/media/video/saa7164/saa7164-core\.c,drivers/media/pci/saa7164/saa7164-core\.c,g' \
	-e 's,drivers/media/video/saa7164/saa7164-dvb\.c,drivers/media/pci/saa7164/saa7164-dvb\.c,g' \
	-e 's,drivers/media/video/saa7164/saa7164-encoder\.c,drivers/media/pci/saa7164/saa7164-encoder\.c,g' \
	-e 's,drivers/media/video/saa7164/saa7164-fw\.c,drivers/media/pci/saa7164/saa7164-fw\.c,g' \
	-e 's,drivers/media/video/saa7164/saa7164-i2c\.c,drivers/media/pci/saa7164/saa7164-i2c\.c,g' \
	-e 's,drivers/media/video/saa7164/saa7164-reg\.h,drivers/media/pci/saa7164/saa7164-reg\.h,g' \
	-e 's,drivers/media/video/saa7164/saa7164-types\.h,drivers/media/pci/saa7164/saa7164-types\.h,g' \
	-e 's,drivers/media/video/saa7164/saa7164-vbi\.c,drivers/media/pci/saa7164/saa7164-vbi\.c,g' \
	-e 's,drivers/media/video/saa7164/saa7164\.h,drivers/media/pci/saa7164/saa7164\.h,g' \
	-e 's,drivers/media/video/sta2x11_vip\.c,drivers/media/pci/sta2x11/sta2x11_vip\.c,g' \
	-e 's,drivers/media/video/sta2x11_vip\.h,drivers/media/pci/sta2x11/sta2x11_vip\.h,g' \
	-e 's,drivers/media/dvb/ttpci/Kconfig,drivers/media/pci/ttpci/Kconfig,g' \
	-e 's,drivers/media/dvb/ttpci/Makefile,drivers/media/pci/ttpci/Makefile,g' \
	-e 's,drivers/media/dvb/ttpci/av7110\.c,drivers/media/pci/ttpci/av7110\.c,g' \
	-e 's,drivers/media/dvb/ttpci/av7110\.h,drivers/media/pci/ttpci/av7110\.h,g' \
	-e 's,drivers/media/dvb/ttpci/av7110_av\.c,drivers/media/pci/ttpci/av7110_av\.c,g' \
	-e 's,drivers/media/dvb/ttpci/av7110_av\.h,drivers/media/pci/ttpci/av7110_av\.h,g' \
	-e 's,drivers/media/dvb/ttpci/av7110_ca\.c,drivers/media/pci/ttpci/av7110_ca\.c,g' \
	-e 's,drivers/media/dvb/ttpci/av7110_ca\.h,drivers/media/pci/ttpci/av7110_ca\.h,g' \
	-e 's,drivers/media/dvb/ttpci/av7110_hw\.c,drivers/media/pci/ttpci/av7110_hw\.c,g' \
	-e 's,drivers/media/dvb/ttpci/av7110_hw\.h,drivers/media/pci/ttpci/av7110_hw\.h,g' \
	-e 's,drivers/media/dvb/ttpci/av7110_ipack\.c,drivers/media/pci/ttpci/av7110_ipack\.c,g' \
	-e 's,drivers/media/dvb/ttpci/av7110_ipack\.h,drivers/media/pci/ttpci/av7110_ipack\.h,g' \
	-e 's,drivers/media/dvb/ttpci/av7110_ir\.c,drivers/media/pci/ttpci/av7110_ir\.c,g' \
	-e 's,drivers/media/dvb/ttpci/av7110_v4l\.c,drivers/media/pci/ttpci/av7110_v4l\.c,g' \
	-e 's,drivers/media/dvb/ttpci/budget-av\.c,drivers/media/pci/ttpci/budget-av\.c,g' \
	-e 's,drivers/media/dvb/ttpci/budget-ci\.c,drivers/media/pci/ttpci/budget-ci\.c,g' \
	-e 's,drivers/media/dvb/ttpci/budget-core\.c,drivers/media/pci/ttpci/budget-core\.c,g' \
	-e 's,drivers/media/dvb/ttpci/budget-patch\.c,drivers/media/pci/ttpci/budget-patch\.c,g' \
	-e 's,drivers/media/dvb/ttpci/budget\.c,drivers/media/pci/ttpci/budget\.c,g' \
	-e 's,drivers/media/dvb/ttpci/budget\.h,drivers/media/pci/ttpci/budget\.h,g' \
	-e 's,drivers/media/dvb/ttpci/ttpci-eeprom\.c,drivers/media/pci/ttpci/ttpci-eeprom\.c,g' \
	-e 's,drivers/media/dvb/ttpci/ttpci-eeprom\.h,drivers/media/pci/ttpci/ttpci-eeprom\.h,g' \
	-e 's,drivers/media/video/zoran/Kconfig,drivers/media/pci/zoran/Kconfig,g' \
	-e 's,drivers/media/video/zoran/Makefile,drivers/media/pci/zoran/Makefile,g' \
	-e 's,drivers/media/video/zoran/videocodec\.c,drivers/media/pci/zoran/videocodec\.c,g' \
	-e 's,drivers/media/video/zoran/videocodec\.h,drivers/media/pci/zoran/videocodec\.h,g' \
	-e 's,drivers/media/video/zoran/zoran\.h,drivers/media/pci/zoran/zoran\.h,g' \
	-e 's,drivers/media/video/zoran/zoran_card\.c,drivers/media/pci/zoran/zoran_card\.c,g' \
	-e 's,drivers/media/video/zoran/zoran_card\.h,drivers/media/pci/zoran/zoran_card\.h,g' \
	-e 's,drivers/media/video/zoran/zoran_device\.c,drivers/media/pci/zoran/zoran_device\.c,g' \
	-e 's,drivers/media/video/zoran/zoran_device\.h,drivers/media/pci/zoran/zoran_device\.h,g' \
	-e 's,drivers/media/video/zoran/zoran_driver\.c,drivers/media/pci/zoran/zoran_driver\.c,g' \
	-e 's,drivers/media/video/zoran/zoran_procfs\.c,drivers/media/pci/zoran/zoran_procfs\.c,g' \
	-e 's,drivers/media/video/zoran/zoran_procfs\.h,drivers/media/pci/zoran/zoran_procfs\.h,g' \
	-e 's,drivers/media/video/zoran/zr36016\.c,drivers/media/pci/zoran/zr36016\.c,g' \
	-e 's,drivers/media/video/zoran/zr36016\.h,drivers/media/pci/zoran/zr36016\.h,g' \
	-e 's,drivers/media/video/zoran/zr36050\.c,drivers/media/pci/zoran/zr36050\.c,g' \
	-e 's,drivers/media/video/zoran/zr36050\.h,drivers/media/pci/zoran/zr36050\.h,g' \
	-e 's,drivers/media/video/zoran/zr36057\.h,drivers/media/pci/zoran/zr36057\.h,g' \
	-e 's,drivers/media/video/zoran/zr36060\.c,drivers/media/pci/zoran/zr36060\.c,g' \
	-e 's,drivers/media/video/zoran/zr36060\.h,drivers/media/pci/zoran/zr36060\.h,g' \
	-e 's,drivers/media/video/arv\.c,drivers/media/platform/arv\.c,g' \
	-e 's,drivers/media/video/blackfin/Kconfig,drivers/media/platform/blackfin/Kconfig,g' \
	-e 's,drivers/media/video/blackfin/Makefile,drivers/media/platform/blackfin/Makefile,g' \
	-e 's,drivers/media/video/blackfin/bfin_capture\.c,drivers/media/platform/blackfin/bfin_capture\.c,g' \
	-e 's,drivers/media/video/blackfin/ppi\.c,drivers/media/platform/blackfin/ppi\.c,g' \
	-e 's,drivers/media/video/coda\.c,drivers/media/platform/coda\.c,g' \
	-e 's,drivers/media/video/coda\.h,drivers/media/platform/coda\.h,g' \
	-e 's,drivers/media/video/davinci/Kconfig,drivers/media/platform/davinci/Kconfig,g' \
	-e 's,drivers/media/video/davinci/Makefile,drivers/media/platform/davinci/Makefile,g' \
	-e 's,drivers/media/video/davinci/ccdc_hw_device\.h,drivers/media/platform/davinci/ccdc_hw_device\.h,g' \
	-e 's,drivers/media/video/davinci/dm355_ccdc\.c,drivers/media/platform/davinci/dm355_ccdc\.c,g' \
	-e 's,drivers/media/video/davinci/dm355_ccdc_regs\.h,drivers/media/platform/davinci/dm355_ccdc_regs\.h,g' \
	-e 's,drivers/media/video/davinci/dm644x_ccdc\.c,drivers/media/platform/davinci/dm644x_ccdc\.c,g' \
	-e 's,drivers/media/video/davinci/dm644x_ccdc_regs\.h,drivers/media/platform/davinci/dm644x_ccdc_regs\.h,g' \
	-e 's,drivers/media/video/davinci/isif\.c,drivers/media/platform/davinci/isif\.c,g' \
	-e 's,drivers/media/video/davinci/isif_regs\.h,drivers/media/platform/davinci/isif_regs\.h,g' \
	-e 's,drivers/media/video/davinci/vpbe\.c,drivers/media/platform/davinci/vpbe\.c,g' \
	-e 's,drivers/media/video/davinci/vpbe_display\.c,drivers/media/platform/davinci/vpbe_display\.c,g' \
	-e 's,drivers/media/video/davinci/vpbe_osd\.c,drivers/media/platform/davinci/vpbe_osd\.c,g' \
	-e 's,drivers/media/video/davinci/vpbe_osd_regs\.h,drivers/media/platform/davinci/vpbe_osd_regs\.h,g' \
	-e 's,drivers/media/video/davinci/vpbe_venc\.c,drivers/media/platform/davinci/vpbe_venc\.c,g' \
	-e 's,drivers/media/video/davinci/vpbe_venc_regs\.h,drivers/media/platform/davinci/vpbe_venc_regs\.h,g' \
	-e 's,drivers/media/video/davinci/vpfe_capture\.c,drivers/media/platform/davinci/vpfe_capture\.c,g' \
	-e 's,drivers/media/video/davinci/vpif\.c,drivers/media/platform/davinci/vpif\.c,g' \
	-e 's,drivers/media/video/davinci/vpif\.h,drivers/media/platform/davinci/vpif\.h,g' \
	-e 's,drivers/media/video/davinci/vpif_capture\.c,drivers/media/platform/davinci/vpif_capture\.c,g' \
	-e 's,drivers/media/video/davinci/vpif_capture\.h,drivers/media/platform/davinci/vpif_capture\.h,g' \
	-e 's,drivers/media/video/davinci/vpif_display\.c,drivers/media/platform/davinci/vpif_display\.c,g' \
	-e 's,drivers/media/video/davinci/vpif_display\.h,drivers/media/platform/davinci/vpif_display\.h,g' \
	-e 's,drivers/media/video/davinci/vpss\.c,drivers/media/platform/davinci/vpss\.c,g' \
	-e 's,drivers/media/video/fsl-viu\.c,drivers/media/platform/fsl-viu\.c,g' \
	-e 's,drivers/media/video/indycam\.c,drivers/media/platform/indycam\.c,g' \
	-e 's,drivers/media/video/indycam\.h,drivers/media/platform/indycam\.h,g' \
	-e 's,drivers/media/video/m2m-deinterlace\.c,drivers/media/platform/m2m-deinterlace\.c,g' \
	-e 's,drivers/media/video/marvell-ccic/Kconfig,drivers/media/platform/marvell-ccic/Kconfig,g' \
	-e 's,drivers/media/video/marvell-ccic/Makefile,drivers/media/platform/marvell-ccic/Makefile,g' \
	-e 's,drivers/media/video/marvell-ccic/cafe-driver\.c,drivers/media/platform/marvell-ccic/cafe-driver\.c,g' \
	-e 's,drivers/media/video/marvell-ccic/mcam-core\.c,drivers/media/platform/marvell-ccic/mcam-core\.c,g' \
	-e 's,drivers/media/video/marvell-ccic/mcam-core\.h,drivers/media/platform/marvell-ccic/mcam-core\.h,g' \
	-e 's,drivers/media/video/marvell-ccic/mmp-driver\.c,drivers/media/platform/marvell-ccic/mmp-driver\.c,g' \
	-e 's,drivers/media/video/mem2mem_testdev\.c,drivers/media/platform/mem2mem_testdev\.c,g' \
	-e 's,drivers/media/video/mx2_emmaprp\.c,drivers/media/platform/mx2_emmaprp\.c,g' \
	-e 's,drivers/media/video/omap/Kconfig,drivers/media/platform/omap/Kconfig,g' \
	-e 's,drivers/media/video/omap/Makefile,drivers/media/platform/omap/Makefile,g' \
	-e 's,drivers/media/video/omap/omap_vout\.c,drivers/media/platform/omap/omap_vout\.c,g' \
	-e 's,drivers/media/video/omap/omap_vout_vrfb\.c,drivers/media/platform/omap/omap_vout_vrfb\.c,g' \
	-e 's,drivers/media/video/omap/omap_vout_vrfb\.h,drivers/media/platform/omap/omap_vout_vrfb\.h,g' \
	-e 's,drivers/media/video/omap/omap_voutdef\.h,drivers/media/platform/omap/omap_voutdef\.h,g' \
	-e 's,drivers/media/video/omap/omap_voutlib\.c,drivers/media/platform/omap/omap_voutlib\.c,g' \
	-e 's,drivers/media/video/omap/omap_voutlib\.h,drivers/media/platform/omap/omap_voutlib\.h,g' \
	-e 's,drivers/media/video/omap24xxcam-dma\.c,drivers/media/platform/omap24xxcam-dma\.c,g' \
	-e 's,drivers/media/video/omap24xxcam\.c,drivers/media/platform/omap24xxcam\.c,g' \
	-e 's,drivers/media/video/omap24xxcam\.h,drivers/media/platform/omap24xxcam\.h,g' \
	-e 's,drivers/media/video/omap3isp/Makefile,drivers/media/platform/omap3isp/Makefile,g' \
	-e 's,drivers/media/video/omap3isp/cfa_coef_table\.h,drivers/media/platform/omap3isp/cfa_coef_table\.h,g' \
	-e 's,drivers/media/video/omap3isp/gamma_table\.h,drivers/media/platform/omap3isp/gamma_table\.h,g' \
	-e 's,drivers/media/video/omap3isp/isp\.c,drivers/media/platform/omap3isp/isp\.c,g' \
	-e 's,drivers/media/video/omap3isp/isp\.h,drivers/media/platform/omap3isp/isp\.h,g' \
	-e 's,drivers/media/video/omap3isp/ispccdc\.c,drivers/media/platform/omap3isp/ispccdc\.c,g' \
	-e 's,drivers/media/video/omap3isp/ispccdc\.h,drivers/media/platform/omap3isp/ispccdc\.h,g' \
	-e 's,drivers/media/video/omap3isp/ispccp2\.c,drivers/media/platform/omap3isp/ispccp2\.c,g' \
	-e 's,drivers/media/video/omap3isp/ispccp2\.h,drivers/media/platform/omap3isp/ispccp2\.h,g' \
	-e 's,drivers/media/video/omap3isp/ispcsi2\.c,drivers/media/platform/omap3isp/ispcsi2\.c,g' \
	-e 's,drivers/media/video/omap3isp/ispcsi2\.h,drivers/media/platform/omap3isp/ispcsi2\.h,g' \
	-e 's,drivers/media/video/omap3isp/ispcsiphy\.c,drivers/media/platform/omap3isp/ispcsiphy\.c,g' \
	-e 's,drivers/media/video/omap3isp/ispcsiphy\.h,drivers/media/platform/omap3isp/ispcsiphy\.h,g' \
	-e 's,drivers/media/video/omap3isp/isph3a\.h,drivers/media/platform/omap3isp/isph3a\.h,g' \
	-e 's,drivers/media/video/omap3isp/isph3a_aewb\.c,drivers/media/platform/omap3isp/isph3a_aewb\.c,g' \
	-e 's,drivers/media/video/omap3isp/isph3a_af\.c,drivers/media/platform/omap3isp/isph3a_af\.c,g' \
	-e 's,drivers/media/video/omap3isp/isphist\.c,drivers/media/platform/omap3isp/isphist\.c,g' \
	-e 's,drivers/media/video/omap3isp/isphist\.h,drivers/media/platform/omap3isp/isphist\.h,g' \
	-e 's,drivers/media/video/omap3isp/isppreview\.c,drivers/media/platform/omap3isp/isppreview\.c,g' \
	-e 's,drivers/media/video/omap3isp/isppreview\.h,drivers/media/platform/omap3isp/isppreview\.h,g' \
	-e 's,drivers/media/video/omap3isp/ispqueue\.c,drivers/media/platform/omap3isp/ispqueue\.c,g' \
	-e 's,drivers/media/video/omap3isp/ispqueue\.h,drivers/media/platform/omap3isp/ispqueue\.h,g' \
	-e 's,drivers/media/video/omap3isp/ispreg\.h,drivers/media/platform/omap3isp/ispreg\.h,g' \
	-e 's,drivers/media/video/omap3isp/ispresizer\.c,drivers/media/platform/omap3isp/ispresizer\.c,g' \
	-e 's,drivers/media/video/omap3isp/ispresizer\.h,drivers/media/platform/omap3isp/ispresizer\.h,g' \
	-e 's,drivers/media/video/omap3isp/ispstat\.c,drivers/media/platform/omap3isp/ispstat\.c,g' \
	-e 's,drivers/media/video/omap3isp/ispstat\.h,drivers/media/platform/omap3isp/ispstat\.h,g' \
	-e 's,drivers/media/video/omap3isp/ispvideo\.c,drivers/media/platform/omap3isp/ispvideo\.c,g' \
	-e 's,drivers/media/video/omap3isp/ispvideo\.h,drivers/media/platform/omap3isp/ispvideo\.h,g' \
	-e 's,drivers/media/video/omap3isp/luma_enhance_table\.h,drivers/media/platform/omap3isp/luma_enhance_table\.h,g' \
	-e 's,drivers/media/video/omap3isp/noise_filter_table\.h,drivers/media/platform/omap3isp/noise_filter_table\.h,g' \
	-e 's,drivers/media/video/s5p-fimc/Kconfig,drivers/media/platform/s5p-fimc/Kconfig,g' \
	-e 's,drivers/media/video/s5p-fimc/Makefile,drivers/media/platform/s5p-fimc/Makefile,g' \
	-e 's,drivers/media/video/s5p-fimc/fimc-capture\.c,drivers/media/platform/s5p-fimc/fimc-capture\.c,g' \
	-e 's,drivers/media/video/s5p-fimc/fimc-core\.c,drivers/media/platform/s5p-fimc/fimc-core\.c,g' \
	-e 's,drivers/media/video/s5p-fimc/fimc-core\.h,drivers/media/platform/s5p-fimc/fimc-core\.h,g' \
	-e 's,drivers/media/video/s5p-fimc/fimc-lite-reg\.c,drivers/media/platform/s5p-fimc/fimc-lite-reg\.c,g' \
	-e 's,drivers/media/video/s5p-fimc/fimc-lite-reg\.h,drivers/media/platform/s5p-fimc/fimc-lite-reg\.h,g' \
	-e 's,drivers/media/video/s5p-fimc/fimc-lite\.c,drivers/media/platform/s5p-fimc/fimc-lite\.c,g' \
	-e 's,drivers/media/video/s5p-fimc/fimc-lite\.h,drivers/media/platform/s5p-fimc/fimc-lite\.h,g' \
	-e 's,drivers/media/video/s5p-fimc/fimc-m2m\.c,drivers/media/platform/s5p-fimc/fimc-m2m\.c,g' \
	-e 's,drivers/media/video/s5p-fimc/fimc-mdevice\.c,drivers/media/platform/s5p-fimc/fimc-mdevice\.c,g' \
	-e 's,drivers/media/video/s5p-fimc/fimc-mdevice\.h,drivers/media/platform/s5p-fimc/fimc-mdevice\.h,g' \
	-e 's,drivers/media/video/s5p-fimc/fimc-reg\.c,drivers/media/platform/s5p-fimc/fimc-reg\.c,g' \
	-e 's,drivers/media/video/s5p-fimc/fimc-reg\.h,drivers/media/platform/s5p-fimc/fimc-reg\.h,g' \
	-e 's,drivers/media/video/s5p-fimc/mipi-csis\.c,drivers/media/platform/s5p-fimc/mipi-csis\.c,g' \
	-e 's,drivers/media/video/s5p-fimc/mipi-csis\.h,drivers/media/platform/s5p-fimc/mipi-csis\.h,g' \
	-e 's,drivers/media/video/s5p-g2d/Makefile,drivers/media/platform/s5p-g2d/Makefile,g' \
	-e 's,drivers/media/video/s5p-g2d/g2d-hw\.c,drivers/media/platform/s5p-g2d/g2d-hw\.c,g' \
	-e 's,drivers/media/video/s5p-g2d/g2d-regs\.h,drivers/media/platform/s5p-g2d/g2d-regs\.h,g' \
	-e 's,drivers/media/video/s5p-g2d/g2d\.c,drivers/media/platform/s5p-g2d/g2d\.c,g' \
	-e 's,drivers/media/video/s5p-g2d/g2d\.h,drivers/media/platform/s5p-g2d/g2d\.h,g' \
	-e 's,drivers/media/video/s5p-jpeg/Makefile,drivers/media/platform/s5p-jpeg/Makefile,g' \
	-e 's,drivers/media/video/s5p-jpeg/jpeg-core\.c,drivers/media/platform/s5p-jpeg/jpeg-core\.c,g' \
	-e 's,drivers/media/video/s5p-jpeg/jpeg-core\.h,drivers/media/platform/s5p-jpeg/jpeg-core\.h,g' \
	-e 's,drivers/media/video/s5p-jpeg/jpeg-hw\.h,drivers/media/platform/s5p-jpeg/jpeg-hw\.h,g' \
	-e 's,drivers/media/video/s5p-jpeg/jpeg-regs\.h,drivers/media/platform/s5p-jpeg/jpeg-regs\.h,g' \
	-e 's,drivers/media/video/s5p-mfc/Makefile,drivers/media/platform/s5p-mfc/Makefile,g' \
	-e 's,drivers/media/video/s5p-mfc/regs-mfc\.h,drivers/media/platform/s5p-mfc/regs-mfc\.h,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc\.c,drivers/media/platform/s5p-mfc/s5p_mfc\.c,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_cmd\.c,drivers/media/platform/s5p-mfc/s5p_mfc_cmd\.c,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_cmd\.h,drivers/media/platform/s5p-mfc/s5p_mfc_cmd\.h,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_common\.h,drivers/media/platform/s5p-mfc/s5p_mfc_common\.h,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_ctrl\.c,drivers/media/platform/s5p-mfc/s5p_mfc_ctrl\.c,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_ctrl\.h,drivers/media/platform/s5p-mfc/s5p_mfc_ctrl\.h,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_debug\.h,drivers/media/platform/s5p-mfc/s5p_mfc_debug\.h,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_dec\.c,drivers/media/platform/s5p-mfc/s5p_mfc_dec\.c,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_dec\.h,drivers/media/platform/s5p-mfc/s5p_mfc_dec\.h,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_enc\.c,drivers/media/platform/s5p-mfc/s5p_mfc_enc\.c,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_enc\.h,drivers/media/platform/s5p-mfc/s5p_mfc_enc\.h,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_intr\.c,drivers/media/platform/s5p-mfc/s5p_mfc_intr\.c,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_intr\.h,drivers/media/platform/s5p-mfc/s5p_mfc_intr\.h,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_opr\.c,drivers/media/platform/s5p-mfc/s5p_mfc_opr\.c,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_opr\.h,drivers/media/platform/s5p-mfc/s5p_mfc_opr\.h,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_pm\.c,drivers/media/platform/s5p-mfc/s5p_mfc_pm\.c,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_pm\.h,drivers/media/platform/s5p-mfc/s5p_mfc_pm\.h,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_shm\.c,drivers/media/platform/s5p-mfc/s5p_mfc_shm\.c,g' \
	-e 's,drivers/media/video/s5p-mfc/s5p_mfc_shm\.h,drivers/media/platform/s5p-mfc/s5p_mfc_shm\.h,g' \
	-e 's,drivers/media/video/s5p-tv/Kconfig,drivers/media/platform/s5p-tv/Kconfig,g' \
	-e 's,drivers/media/video/s5p-tv/Makefile,drivers/media/platform/s5p-tv/Makefile,g' \
	-e 's,drivers/media/video/s5p-tv/hdmi_drv\.c,drivers/media/platform/s5p-tv/hdmi_drv\.c,g' \
	-e 's,drivers/media/video/s5p-tv/hdmiphy_drv\.c,drivers/media/platform/s5p-tv/hdmiphy_drv\.c,g' \
	-e 's,drivers/media/video/s5p-tv/mixer\.h,drivers/media/platform/s5p-tv/mixer\.h,g' \
	-e 's,drivers/media/video/s5p-tv/mixer_drv\.c,drivers/media/platform/s5p-tv/mixer_drv\.c,g' \
	-e 's,drivers/media/video/s5p-tv/mixer_grp_layer\.c,drivers/media/platform/s5p-tv/mixer_grp_layer\.c,g' \
	-e 's,drivers/media/video/s5p-tv/mixer_reg\.c,drivers/media/platform/s5p-tv/mixer_reg\.c,g' \
	-e 's,drivers/media/video/s5p-tv/mixer_video\.c,drivers/media/platform/s5p-tv/mixer_video\.c,g' \
	-e 's,drivers/media/video/s5p-tv/mixer_vp_layer\.c,drivers/media/platform/s5p-tv/mixer_vp_layer\.c,g' \
	-e 's,drivers/media/video/s5p-tv/regs-hdmi\.h,drivers/media/platform/s5p-tv/regs-hdmi\.h,g' \
	-e 's,drivers/media/video/s5p-tv/regs-mixer\.h,drivers/media/platform/s5p-tv/regs-mixer\.h,g' \
	-e 's,drivers/media/video/s5p-tv/regs-sdo\.h,drivers/media/platform/s5p-tv/regs-sdo\.h,g' \
	-e 's,drivers/media/video/s5p-tv/regs-vp\.h,drivers/media/platform/s5p-tv/regs-vp\.h,g' \
	-e 's,drivers/media/video/s5p-tv/sdo_drv\.c,drivers/media/platform/s5p-tv/sdo_drv\.c,g' \
	-e 's,drivers/media/video/s5p-tv/sii9234_drv\.c,drivers/media/platform/s5p-tv/sii9234_drv\.c,g' \
	-e 's,drivers/media/video/sh_vou\.c,drivers/media/platform/sh_vou\.c,g' \
	-e 's,drivers/media/video/atmel-isi\.c,drivers/media/platform/soc_camera/atmel-isi\.c,g' \
	-e 's,drivers/media/video/mx1_camera\.c,drivers/media/platform/soc_camera/mx1_camera\.c,g' \
	-e 's,drivers/media/video/mx2_camera\.c,drivers/media/platform/soc_camera/mx2_camera\.c,g' \
	-e 's,drivers/media/video/mx3_camera\.c,drivers/media/platform/soc_camera/mx3_camera\.c,g' \
	-e 's,drivers/media/video/omap1_camera\.c,drivers/media/platform/soc_camera/omap1_camera\.c,g' \
	-e 's,drivers/media/video/pxa_camera\.c,drivers/media/platform/soc_camera/pxa_camera\.c,g' \
	-e 's,drivers/media/video/sh_mobile_ceu_camera\.c,drivers/media/platform/soc_camera/sh_mobile_ceu_camera\.c,g' \
	-e 's,drivers/media/video/sh_mobile_csi2\.c,drivers/media/platform/soc_camera/sh_mobile_csi2\.c,g' \
	-e 's,drivers/media/video/soc_camera\.c,drivers/media/platform/soc_camera/soc_camera\.c,g' \
	-e 's,drivers/media/video/soc_camera_platform\.c,drivers/media/platform/soc_camera/soc_camera_platform\.c,g' \
	-e 's,drivers/media/video/soc_mediabus\.c,drivers/media/platform/soc_camera/soc_mediabus\.c,g' \
	-e 's,drivers/media/video/timblogiw\.c,drivers/media/platform/timblogiw\.c,g' \
	-e 's,drivers/media/video/via-camera\.c,drivers/media/platform/via-camera\.c,g' \
	-e 's,drivers/media/video/via-camera\.h,drivers/media/platform/via-camera\.h,g' \
	-e 's,drivers/media/video/vino\.c,drivers/media/platform/vino\.c,g' \
	-e 's,drivers/media/video/vino\.h,drivers/media/platform/vino\.h,g' \
	-e 's,drivers/media/video/vivi\.c,drivers/media/platform/vivi\.c,g' \
	-e 's,drivers/media/common/tuners/Kconfig,drivers/media/tuners/Kconfig,g' \
	-e 's,drivers/media/common/tuners/Makefile,drivers/media/tuners/Makefile,g' \
	-e 's,drivers/media/common/tuners/fc0011\.c,drivers/media/tuners/fc0011\.c,g' \
	-e 's,drivers/media/common/tuners/fc0011\.h,drivers/media/tuners/fc0011\.h,g' \
	-e 's,drivers/media/common/tuners/fc0012-priv\.h,drivers/media/tuners/fc0012-priv\.h,g' \
	-e 's,drivers/media/common/tuners/fc0012\.c,drivers/media/tuners/fc0012\.c,g' \
	-e 's,drivers/media/common/tuners/fc0012\.h,drivers/media/tuners/fc0012\.h,g' \
	-e 's,drivers/media/common/tuners/fc0013-priv\.h,drivers/media/tuners/fc0013-priv\.h,g' \
	-e 's,drivers/media/common/tuners/fc0013\.c,drivers/media/tuners/fc0013\.c,g' \
	-e 's,drivers/media/common/tuners/fc0013\.h,drivers/media/tuners/fc0013\.h,g' \
	-e 's,drivers/media/common/tuners/fc001x-common\.h,drivers/media/tuners/fc001x-common\.h,g' \
	-e 's,drivers/media/common/tuners/max2165\.c,drivers/media/tuners/max2165\.c,g' \
	-e 's,drivers/media/common/tuners/max2165\.h,drivers/media/tuners/max2165\.h,g' \
	-e 's,drivers/media/common/tuners/max2165_priv\.h,drivers/media/tuners/max2165_priv\.h,g' \
	-e 's,drivers/media/common/tuners/mc44s803\.c,drivers/media/tuners/mc44s803\.c,g' \
	-e 's,drivers/media/common/tuners/mc44s803\.h,drivers/media/tuners/mc44s803\.h,g' \
	-e 's,drivers/media/common/tuners/mc44s803_priv\.h,drivers/media/tuners/mc44s803_priv\.h,g' \
	-e 's,drivers/media/common/tuners/mt2060\.c,drivers/media/tuners/mt2060\.c,g' \
	-e 's,drivers/media/common/tuners/mt2060\.h,drivers/media/tuners/mt2060\.h,g' \
	-e 's,drivers/media/common/tuners/mt2060_priv\.h,drivers/media/tuners/mt2060_priv\.h,g' \
	-e 's,drivers/media/common/tuners/mt2063\.c,drivers/media/tuners/mt2063\.c,g' \
	-e 's,drivers/media/common/tuners/mt2063\.h,drivers/media/tuners/mt2063\.h,g' \
	-e 's,drivers/media/common/tuners/mt20xx\.c,drivers/media/tuners/mt20xx\.c,g' \
	-e 's,drivers/media/common/tuners/mt20xx\.h,drivers/media/tuners/mt20xx\.h,g' \
	-e 's,drivers/media/common/tuners/mt2131\.c,drivers/media/tuners/mt2131\.c,g' \
	-e 's,drivers/media/common/tuners/mt2131\.h,drivers/media/tuners/mt2131\.h,g' \
	-e 's,drivers/media/common/tuners/mt2131_priv\.h,drivers/media/tuners/mt2131_priv\.h,g' \
	-e 's,drivers/media/common/tuners/mt2266\.c,drivers/media/tuners/mt2266\.c,g' \
	-e 's,drivers/media/common/tuners/mt2266\.h,drivers/media/tuners/mt2266\.h,g' \
	-e 's,drivers/media/common/tuners/mxl5005s\.c,drivers/media/tuners/mxl5005s\.c,g' \
	-e 's,drivers/media/common/tuners/mxl5005s\.h,drivers/media/tuners/mxl5005s\.h,g' \
	-e 's,drivers/media/common/tuners/mxl5007t\.c,drivers/media/tuners/mxl5007t\.c,g' \
	-e 's,drivers/media/common/tuners/mxl5007t\.h,drivers/media/tuners/mxl5007t\.h,g' \
	-e 's,drivers/media/common/tuners/qt1010\.c,drivers/media/tuners/qt1010\.c,g' \
	-e 's,drivers/media/common/tuners/qt1010\.h,drivers/media/tuners/qt1010\.h,g' \
	-e 's,drivers/media/common/tuners/qt1010_priv\.h,drivers/media/tuners/qt1010_priv\.h,g' \
	-e 's,drivers/media/common/tuners/tda18212\.c,drivers/media/tuners/tda18212\.c,g' \
	-e 's,drivers/media/common/tuners/tda18212\.h,drivers/media/tuners/tda18212\.h,g' \
	-e 's,drivers/media/common/tuners/tda18218\.c,drivers/media/tuners/tda18218\.c,g' \
	-e 's,drivers/media/common/tuners/tda18218\.h,drivers/media/tuners/tda18218\.h,g' \
	-e 's,drivers/media/common/tuners/tda18218_priv\.h,drivers/media/tuners/tda18218_priv\.h,g' \
	-e 's,drivers/media/common/tuners/tda18271-common\.c,drivers/media/tuners/tda18271-common\.c,g' \
	-e 's,drivers/media/common/tuners/tda18271-fe\.c,drivers/media/tuners/tda18271-fe\.c,g' \
	-e 's,drivers/media/common/tuners/tda18271-maps\.c,drivers/media/tuners/tda18271-maps\.c,g' \
	-e 's,drivers/media/common/tuners/tda18271-priv\.h,drivers/media/tuners/tda18271-priv\.h,g' \
	-e 's,drivers/media/common/tuners/tda18271\.h,drivers/media/tuners/tda18271\.h,g' \
	-e 's,drivers/media/common/tuners/tda827x\.c,drivers/media/tuners/tda827x\.c,g' \
	-e 's,drivers/media/common/tuners/tda827x\.h,drivers/media/tuners/tda827x\.h,g' \
	-e 's,drivers/media/common/tuners/tda8290\.c,drivers/media/tuners/tda8290\.c,g' \
	-e 's,drivers/media/common/tuners/tda8290\.h,drivers/media/tuners/tda8290\.h,g' \
	-e 's,drivers/media/common/tuners/tda9887\.c,drivers/media/tuners/tda9887\.c,g' \
	-e 's,drivers/media/common/tuners/tda9887\.h,drivers/media/tuners/tda9887\.h,g' \
	-e 's,drivers/media/common/tuners/tea5761\.c,drivers/media/tuners/tea5761\.c,g' \
	-e 's,drivers/media/common/tuners/tea5761\.h,drivers/media/tuners/tea5761\.h,g' \
	-e 's,drivers/media/common/tuners/tea5767\.c,drivers/media/tuners/tea5767\.c,g' \
	-e 's,drivers/media/common/tuners/tea5767\.h,drivers/media/tuners/tea5767\.h,g' \
	-e 's,drivers/media/common/tuners/tua9001\.c,drivers/media/tuners/tua9001\.c,g' \
	-e 's,drivers/media/common/tuners/tua9001\.h,drivers/media/tuners/tua9001\.h,g' \
	-e 's,drivers/media/common/tuners/tua9001_priv\.h,drivers/media/tuners/tua9001_priv\.h,g' \
	-e 's,drivers/media/common/tuners/tuner-i2c\.h,drivers/media/tuners/tuner-i2c\.h,g' \
	-e 's,drivers/media/common/tuners/tuner-simple\.c,drivers/media/tuners/tuner-simple\.c,g' \
	-e 's,drivers/media/common/tuners/tuner-simple\.h,drivers/media/tuners/tuner-simple\.h,g' \
	-e 's,drivers/media/common/tuners/tuner-types\.c,drivers/media/tuners/tuner-types\.c,g' \
	-e 's,drivers/media/common/tuners/tuner-xc2028-types\.h,drivers/media/tuners/tuner-xc2028-types\.h,g' \
	-e 's,drivers/media/common/tuners/tuner-xc2028\.c,drivers/media/tuners/tuner-xc2028\.c,g' \
	-e 's,drivers/media/common/tuners/tuner-xc2028\.h,drivers/media/tuners/tuner-xc2028\.h,g' \
	-e 's,drivers/media/common/tuners/xc4000\.c,drivers/media/tuners/xc4000\.c,g' \
	-e 's,drivers/media/common/tuners/xc4000\.h,drivers/media/tuners/xc4000\.h,g' \
	-e 's,drivers/media/common/tuners/xc5000\.c,drivers/media/tuners/xc5000\.c,g' \
	-e 's,drivers/media/common/tuners/xc5000\.h,drivers/media/tuners/xc5000\.h,g' \
	-e 's,drivers/media/video/au0828/Kconfig,drivers/media/usb/au0828/Kconfig,g' \
	-e 's,drivers/media/video/au0828/Makefile,drivers/media/usb/au0828/Makefile,g' \
	-e 's,drivers/media/video/au0828/au0828-cards\.c,drivers/media/usb/au0828/au0828-cards\.c,g' \
	-e 's,drivers/media/video/au0828/au0828-cards\.h,drivers/media/usb/au0828/au0828-cards\.h,g' \
	-e 's,drivers/media/video/au0828/au0828-core\.c,drivers/media/usb/au0828/au0828-core\.c,g' \
	-e 's,drivers/media/video/au0828/au0828-dvb\.c,drivers/media/usb/au0828/au0828-dvb\.c,g' \
	-e 's,drivers/media/video/au0828/au0828-i2c\.c,drivers/media/usb/au0828/au0828-i2c\.c,g' \
	-e 's,drivers/media/video/au0828/au0828-reg\.h,drivers/media/usb/au0828/au0828-reg\.h,g' \
	-e 's,drivers/media/video/au0828/au0828-vbi\.c,drivers/media/usb/au0828/au0828-vbi\.c,g' \
	-e 's,drivers/media/video/au0828/au0828-video\.c,drivers/media/usb/au0828/au0828-video\.c,g' \
	-e 's,drivers/media/video/au0828/au0828\.h,drivers/media/usb/au0828/au0828\.h,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop-usb\.c,drivers/media/usb/b2c2/flexcop-usb\.c,g' \
	-e 's,drivers/media/dvb/b2c2/flexcop-usb\.h,drivers/media/usb/b2c2/flexcop-usb\.h,g' \
	-e 's,drivers/media/video/cpia2/Kconfig,drivers/media/usb/cpia2/Kconfig,g' \
	-e 's,drivers/media/video/cpia2/Makefile,drivers/media/usb/cpia2/Makefile,g' \
	-e 's,drivers/media/video/cpia2/cpia2\.h,drivers/media/usb/cpia2/cpia2\.h,g' \
	-e 's,drivers/media/video/cpia2/cpia2_core\.c,drivers/media/usb/cpia2/cpia2_core\.c,g' \
	-e 's,drivers/media/video/cpia2/cpia2_registers\.h,drivers/media/usb/cpia2/cpia2_registers\.h,g' \
	-e 's,drivers/media/video/cpia2/cpia2_usb\.c,drivers/media/usb/cpia2/cpia2_usb\.c,g' \
	-e 's,drivers/media/video/cpia2/cpia2_v4l\.c,drivers/media/usb/cpia2/cpia2_v4l\.c,g' \
	-e 's,drivers/media/video/cx231xx/Kconfig,drivers/media/usb/cx231xx/Kconfig,g' \
	-e 's,drivers/media/video/cx231xx/Makefile,drivers/media/usb/cx231xx/Makefile,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-417\.c,drivers/media/usb/cx231xx/cx231xx-417\.c,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-audio\.c,drivers/media/usb/cx231xx/cx231xx-audio\.c,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-avcore\.c,drivers/media/usb/cx231xx/cx231xx-avcore\.c,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-cards\.c,drivers/media/usb/cx231xx/cx231xx-cards\.c,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-conf-reg\.h,drivers/media/usb/cx231xx/cx231xx-conf-reg\.h,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-core\.c,drivers/media/usb/cx231xx/cx231xx-core\.c,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-dif\.h,drivers/media/usb/cx231xx/cx231xx-dif\.h,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-dvb\.c,drivers/media/usb/cx231xx/cx231xx-dvb\.c,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-i2c\.c,drivers/media/usb/cx231xx/cx231xx-i2c\.c,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-input\.c,drivers/media/usb/cx231xx/cx231xx-input\.c,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-pcb-cfg\.c,drivers/media/usb/cx231xx/cx231xx-pcb-cfg\.c,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-pcb-cfg\.h,drivers/media/usb/cx231xx/cx231xx-pcb-cfg\.h,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-reg\.h,drivers/media/usb/cx231xx/cx231xx-reg\.h,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-vbi\.c,drivers/media/usb/cx231xx/cx231xx-vbi\.c,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-vbi\.h,drivers/media/usb/cx231xx/cx231xx-vbi\.h,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx-video\.c,drivers/media/usb/cx231xx/cx231xx-video\.c,g' \
	-e 's,drivers/media/video/cx231xx/cx231xx\.h,drivers/media/usb/cx231xx/cx231xx\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/Kconfig,drivers/media/usb/dvb-usb-v2/Kconfig,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/Makefile,drivers/media/usb/dvb-usb-v2/Makefile,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/af9015\.c,drivers/media/usb/dvb-usb-v2/af9015\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/af9015\.h,drivers/media/usb/dvb-usb-v2/af9015\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/af9035\.c,drivers/media/usb/dvb-usb-v2/af9035\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/af9035\.h,drivers/media/usb/dvb-usb-v2/af9035\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/anysee\.c,drivers/media/usb/dvb-usb-v2/anysee\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/anysee\.h,drivers/media/usb/dvb-usb-v2/anysee\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/au6610\.c,drivers/media/usb/dvb-usb-v2/au6610\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/au6610\.h,drivers/media/usb/dvb-usb-v2/au6610\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/az6007\.c,drivers/media/usb/dvb-usb-v2/az6007\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/ce6230\.c,drivers/media/usb/dvb-usb-v2/ce6230\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/ce6230\.h,drivers/media/usb/dvb-usb-v2/ce6230\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/cypress_firmware\.c,drivers/media/usb/dvb-usb-v2/cypress_firmware\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/cypress_firmware\.h,drivers/media/usb/dvb-usb-v2/cypress_firmware\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/dvb_usb\.h,drivers/media/usb/dvb-usb-v2/dvb_usb\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/dvb_usb_common\.h,drivers/media/usb/dvb-usb-v2/dvb_usb_common\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/dvb_usb_core\.c,drivers/media/usb/dvb-usb-v2/dvb_usb_core\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/dvb_usb_urb\.c,drivers/media/usb/dvb-usb-v2/dvb_usb_urb\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/ec168\.c,drivers/media/usb/dvb-usb-v2/ec168\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/ec168\.h,drivers/media/usb/dvb-usb-v2/ec168\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/gl861\.c,drivers/media/usb/dvb-usb-v2/gl861\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/gl861\.h,drivers/media/usb/dvb-usb-v2/gl861\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/it913x\.c,drivers/media/usb/dvb-usb-v2/it913x\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/lmedm04\.c,drivers/media/usb/dvb-usb-v2/lmedm04\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/lmedm04\.h,drivers/media/usb/dvb-usb-v2/lmedm04\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf-demod\.c,drivers/media/usb/dvb-usb-v2/mxl111sf-demod\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf-demod\.h,drivers/media/usb/dvb-usb-v2/mxl111sf-demod\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf-gpio\.c,drivers/media/usb/dvb-usb-v2/mxl111sf-gpio\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf-gpio\.h,drivers/media/usb/dvb-usb-v2/mxl111sf-gpio\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf-i2c\.c,drivers/media/usb/dvb-usb-v2/mxl111sf-i2c\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf-i2c\.h,drivers/media/usb/dvb-usb-v2/mxl111sf-i2c\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf-phy\.c,drivers/media/usb/dvb-usb-v2/mxl111sf-phy\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf-phy\.h,drivers/media/usb/dvb-usb-v2/mxl111sf-phy\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf-reg\.h,drivers/media/usb/dvb-usb-v2/mxl111sf-reg\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf-tuner\.c,drivers/media/usb/dvb-usb-v2/mxl111sf-tuner\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf-tuner\.h,drivers/media/usb/dvb-usb-v2/mxl111sf-tuner\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf\.c,drivers/media/usb/dvb-usb-v2/mxl111sf\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/mxl111sf\.h,drivers/media/usb/dvb-usb-v2/mxl111sf\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/rtl28xxu\.c,drivers/media/usb/dvb-usb-v2/rtl28xxu\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/rtl28xxu\.h,drivers/media/usb/dvb-usb-v2/rtl28xxu\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb-v2/usb_urb\.c,drivers/media/usb/dvb-usb-v2/usb_urb\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/Kconfig,drivers/media/usb/dvb-usb/Kconfig,g' \
	-e 's,drivers/media/dvb/dvb-usb/Makefile,drivers/media/usb/dvb-usb/Makefile,g' \
	-e 's,drivers/media/dvb/dvb-usb/a800\.c,drivers/media/usb/dvb-usb/a800\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/af9005-fe\.c,drivers/media/usb/dvb-usb/af9005-fe\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/af9005-remote\.c,drivers/media/usb/dvb-usb/af9005-remote\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/af9005-script\.h,drivers/media/usb/dvb-usb/af9005-script\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/af9005\.c,drivers/media/usb/dvb-usb/af9005\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/af9005\.h,drivers/media/usb/dvb-usb/af9005\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/az6027\.c,drivers/media/usb/dvb-usb/az6027\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/az6027\.h,drivers/media/usb/dvb-usb/az6027\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/cinergyT2-core\.c,drivers/media/usb/dvb-usb/cinergyT2-core\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/cinergyT2-fe\.c,drivers/media/usb/dvb-usb/cinergyT2-fe\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/cinergyT2\.h,drivers/media/usb/dvb-usb/cinergyT2\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/cxusb\.c,drivers/media/usb/dvb-usb/cxusb\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/cxusb\.h,drivers/media/usb/dvb-usb/cxusb\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/dib0700\.h,drivers/media/usb/dvb-usb/dib0700\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/dib0700_core\.c,drivers/media/usb/dvb-usb/dib0700_core\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dib0700_devices\.c,drivers/media/usb/dvb-usb/dib0700_devices\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dib07x0\.h,drivers/media/usb/dvb-usb/dib07x0\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/dibusb-common\.c,drivers/media/usb/dvb-usb/dibusb-common\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dibusb-mb\.c,drivers/media/usb/dvb-usb/dibusb-mb\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dibusb-mc\.c,drivers/media/usb/dvb-usb/dibusb-mc\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dibusb\.h,drivers/media/usb/dvb-usb/dibusb\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/digitv\.c,drivers/media/usb/dvb-usb/digitv\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/digitv\.h,drivers/media/usb/dvb-usb/digitv\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/dtt200u-fe\.c,drivers/media/usb/dvb-usb/dtt200u-fe\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dtt200u\.c,drivers/media/usb/dvb-usb/dtt200u\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dtt200u\.h,drivers/media/usb/dvb-usb/dtt200u\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/dtv5100\.c,drivers/media/usb/dvb-usb/dtv5100\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dtv5100\.h,drivers/media/usb/dvb-usb/dtv5100\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/dvb-usb-common\.h,drivers/media/usb/dvb-usb/dvb-usb-common\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/dvb-usb-dvb\.c,drivers/media/usb/dvb-usb/dvb-usb-dvb\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dvb-usb-firmware\.c,drivers/media/usb/dvb-usb/dvb-usb-firmware\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dvb-usb-i2c\.c,drivers/media/usb/dvb-usb/dvb-usb-i2c\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dvb-usb-init\.c,drivers/media/usb/dvb-usb/dvb-usb-init\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dvb-usb-remote\.c,drivers/media/usb/dvb-usb/dvb-usb-remote\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dvb-usb-urb\.c,drivers/media/usb/dvb-usb/dvb-usb-urb\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dvb-usb\.h,drivers/media/usb/dvb-usb/dvb-usb\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/dvb_usb_dvb\.c,drivers/media/usb/dvb-usb/dvb_usb_dvb\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dvb_usb_remote\.c,drivers/media/usb/dvb-usb/dvb_usb_remote\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dw2102\.c,drivers/media/usb/dvb-usb/dw2102\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/dw2102\.h,drivers/media/usb/dvb-usb/dw2102\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/friio-fe\.c,drivers/media/usb/dvb-usb/friio-fe\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/friio\.c,drivers/media/usb/dvb-usb/friio\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/friio\.h,drivers/media/usb/dvb-usb/friio\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/gp8psk-fe\.c,drivers/media/usb/dvb-usb/gp8psk-fe\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/gp8psk\.c,drivers/media/usb/dvb-usb/gp8psk\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/gp8psk\.h,drivers/media/usb/dvb-usb/gp8psk\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/m920x\.c,drivers/media/usb/dvb-usb/m920x\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/m920x\.h,drivers/media/usb/dvb-usb/m920x\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/nova-t-usb2\.c,drivers/media/usb/dvb-usb/nova-t-usb2\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/opera1\.c,drivers/media/usb/dvb-usb/opera1\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/pctv452e\.c,drivers/media/usb/dvb-usb/pctv452e\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/technisat-usb2\.c,drivers/media/usb/dvb-usb/technisat-usb2\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/ttusb2\.c,drivers/media/usb/dvb-usb/ttusb2\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/ttusb2\.h,drivers/media/usb/dvb-usb/ttusb2\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/umt-010\.c,drivers/media/usb/dvb-usb/umt-010\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/usb-urb\.c,drivers/media/usb/dvb-usb/usb-urb\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/vp702x-fe\.c,drivers/media/usb/dvb-usb/vp702x-fe\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/vp702x\.c,drivers/media/usb/dvb-usb/vp702x\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/vp702x\.h,drivers/media/usb/dvb-usb/vp702x\.h,g' \
	-e 's,drivers/media/dvb/dvb-usb/vp7045-fe\.c,drivers/media/usb/dvb-usb/vp7045-fe\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/vp7045\.c,drivers/media/usb/dvb-usb/vp7045\.c,g' \
	-e 's,drivers/media/dvb/dvb-usb/vp7045\.h,drivers/media/usb/dvb-usb/vp7045\.h,g' \
	-e 's,drivers/media/video/em28xx/Kconfig,drivers/media/usb/em28xx/Kconfig,g' \
	-e 's,drivers/media/video/em28xx/Makefile,drivers/media/usb/em28xx/Makefile,g' \
	-e 's,drivers/media/video/em28xx/em28xx-audio\.c,drivers/media/usb/em28xx/em28xx-audio\.c,g' \
	-e 's,drivers/media/video/em28xx/em28xx-cards\.c,drivers/media/usb/em28xx/em28xx-cards\.c,g' \
	-e 's,drivers/media/video/em28xx/em28xx-core\.c,drivers/media/usb/em28xx/em28xx-core\.c,g' \
	-e 's,drivers/media/video/em28xx/em28xx-dvb\.c,drivers/media/usb/em28xx/em28xx-dvb\.c,g' \
	-e 's,drivers/media/video/em28xx/em28xx-i2c\.c,drivers/media/usb/em28xx/em28xx-i2c\.c,g' \
	-e 's,drivers/media/video/em28xx/em28xx-input\.c,drivers/media/usb/em28xx/em28xx-input\.c,g' \
	-e 's,drivers/media/video/em28xx/em28xx-reg\.h,drivers/media/usb/em28xx/em28xx-reg\.h,g' \
	-e 's,drivers/media/video/em28xx/em28xx-vbi\.c,drivers/media/usb/em28xx/em28xx-vbi\.c,g' \
	-e 's,drivers/media/video/em28xx/em28xx-video\.c,drivers/media/usb/em28xx/em28xx-video\.c,g' \
	-e 's,drivers/media/video/em28xx/em28xx\.h,drivers/media/usb/em28xx/em28xx\.h,g' \
	-e 's,drivers/media/video/gspca/Kconfig,drivers/media/usb/gspca/Kconfig,g' \
	-e 's,drivers/media/video/gspca/Makefile,drivers/media/usb/gspca/Makefile,g' \
	-e 's,drivers/media/video/gspca/autogain_functions\.c,drivers/media/usb/gspca/autogain_functions\.c,g' \
	-e 's,drivers/media/video/gspca/autogain_functions\.h,drivers/media/usb/gspca/autogain_functions\.h,g' \
	-e 's,drivers/media/video/gspca/benq\.c,drivers/media/usb/gspca/benq\.c,g' \
	-e 's,drivers/media/video/gspca/conex\.c,drivers/media/usb/gspca/conex\.c,g' \
	-e 's,drivers/media/video/gspca/cpia1\.c,drivers/media/usb/gspca/cpia1\.c,g' \
	-e 's,drivers/media/video/gspca/etoms\.c,drivers/media/usb/gspca/etoms\.c,g' \
	-e 's,drivers/media/video/gspca/finepix\.c,drivers/media/usb/gspca/finepix\.c,g' \
	-e 's,drivers/media/video/gspca/gl860/Kconfig,drivers/media/usb/gspca/gl860/Kconfig,g' \
	-e 's,drivers/media/video/gspca/gl860/Makefile,drivers/media/usb/gspca/gl860/Makefile,g' \
	-e 's,drivers/media/video/gspca/gl860/gl860-mi1320\.c,drivers/media/usb/gspca/gl860/gl860-mi1320\.c,g' \
	-e 's,drivers/media/video/gspca/gl860/gl860-mi2020\.c,drivers/media/usb/gspca/gl860/gl860-mi2020\.c,g' \
	-e 's,drivers/media/video/gspca/gl860/gl860-ov2640\.c,drivers/media/usb/gspca/gl860/gl860-ov2640\.c,g' \
	-e 's,drivers/media/video/gspca/gl860/gl860-ov9655\.c,drivers/media/usb/gspca/gl860/gl860-ov9655\.c,g' \
	-e 's,drivers/media/video/gspca/gl860/gl860\.c,drivers/media/usb/gspca/gl860/gl860\.c,g' \
	-e 's,drivers/media/video/gspca/gl860/gl860\.h,drivers/media/usb/gspca/gl860/gl860\.h,g' \
	-e 's,drivers/media/video/gspca/gspca\.c,drivers/media/usb/gspca/gspca\.c,g' \
	-e 's,drivers/media/video/gspca/gspca\.h,drivers/media/usb/gspca/gspca\.h,g' \
	-e 's,drivers/media/video/gspca/jeilinj\.c,drivers/media/usb/gspca/jeilinj\.c,g' \
	-e 's,drivers/media/video/gspca/jl2005bcd\.c,drivers/media/usb/gspca/jl2005bcd\.c,g' \
	-e 's,drivers/media/video/gspca/jpeg\.h,drivers/media/usb/gspca/jpeg\.h,g' \
	-e 's,drivers/media/video/gspca/kinect\.c,drivers/media/usb/gspca/kinect\.c,g' \
	-e 's,drivers/media/video/gspca/konica\.c,drivers/media/usb/gspca/konica\.c,g' \
	-e 's,drivers/media/video/gspca/m5602/Kconfig,drivers/media/usb/gspca/m5602/Kconfig,g' \
	-e 's,drivers/media/video/gspca/m5602/Makefile,drivers/media/usb/gspca/m5602/Makefile,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_bridge\.h,drivers/media/usb/gspca/m5602/m5602_bridge\.h,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_core\.c,drivers/media/usb/gspca/m5602/m5602_core\.c,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_mt9m111\.c,drivers/media/usb/gspca/m5602/m5602_mt9m111\.c,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_mt9m111\.h,drivers/media/usb/gspca/m5602/m5602_mt9m111\.h,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_ov7660\.c,drivers/media/usb/gspca/m5602/m5602_ov7660\.c,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_ov7660\.h,drivers/media/usb/gspca/m5602/m5602_ov7660\.h,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_ov9650\.c,drivers/media/usb/gspca/m5602/m5602_ov9650\.c,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_ov9650\.h,drivers/media/usb/gspca/m5602/m5602_ov9650\.h,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_po1030\.c,drivers/media/usb/gspca/m5602/m5602_po1030\.c,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_po1030\.h,drivers/media/usb/gspca/m5602/m5602_po1030\.h,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_s5k4aa\.c,drivers/media/usb/gspca/m5602/m5602_s5k4aa\.c,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_s5k4aa\.h,drivers/media/usb/gspca/m5602/m5602_s5k4aa\.h,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_s5k83a\.c,drivers/media/usb/gspca/m5602/m5602_s5k83a\.c,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_s5k83a\.h,drivers/media/usb/gspca/m5602/m5602_s5k83a\.h,g' \
	-e 's,drivers/media/video/gspca/m5602/m5602_sensor\.h,drivers/media/usb/gspca/m5602/m5602_sensor\.h,g' \
	-e 's,drivers/media/video/gspca/mars\.c,drivers/media/usb/gspca/mars\.c,g' \
	-e 's,drivers/media/video/gspca/mr97310a\.c,drivers/media/usb/gspca/mr97310a\.c,g' \
	-e 's,drivers/media/video/gspca/nw80x\.c,drivers/media/usb/gspca/nw80x\.c,g' \
	-e 's,drivers/media/video/gspca/ov519\.c,drivers/media/usb/gspca/ov519\.c,g' \
	-e 's,drivers/media/video/gspca/ov534\.c,drivers/media/usb/gspca/ov534\.c,g' \
	-e 's,drivers/media/video/gspca/ov534_9\.c,drivers/media/usb/gspca/ov534_9\.c,g' \
	-e 's,drivers/media/video/gspca/pac207\.c,drivers/media/usb/gspca/pac207\.c,g' \
	-e 's,drivers/media/video/gspca/pac7302\.c,drivers/media/usb/gspca/pac7302\.c,g' \
	-e 's,drivers/media/video/gspca/pac7311\.c,drivers/media/usb/gspca/pac7311\.c,g' \
	-e 's,drivers/media/video/gspca/pac_common\.h,drivers/media/usb/gspca/pac_common\.h,g' \
	-e 's,drivers/media/video/gspca/se401\.c,drivers/media/usb/gspca/se401\.c,g' \
	-e 's,drivers/media/video/gspca/se401\.h,drivers/media/usb/gspca/se401\.h,g' \
	-e 's,drivers/media/video/gspca/sn9c2028\.c,drivers/media/usb/gspca/sn9c2028\.c,g' \
	-e 's,drivers/media/video/gspca/sn9c2028\.h,drivers/media/usb/gspca/sn9c2028\.h,g' \
	-e 's,drivers/media/video/gspca/sn9c20x\.c,drivers/media/usb/gspca/sn9c20x\.c,g' \
	-e 's,drivers/media/video/gspca/sonixb\.c,drivers/media/usb/gspca/sonixb\.c,g' \
	-e 's,drivers/media/video/gspca/sonixj\.c,drivers/media/usb/gspca/sonixj\.c,g' \
	-e 's,drivers/media/video/gspca/spca1528\.c,drivers/media/usb/gspca/spca1528\.c,g' \
	-e 's,drivers/media/video/gspca/spca500\.c,drivers/media/usb/gspca/spca500\.c,g' \
	-e 's,drivers/media/video/gspca/spca501\.c,drivers/media/usb/gspca/spca501\.c,g' \
	-e 's,drivers/media/video/gspca/spca505\.c,drivers/media/usb/gspca/spca505\.c,g' \
	-e 's,drivers/media/video/gspca/spca506\.c,drivers/media/usb/gspca/spca506\.c,g' \
	-e 's,drivers/media/video/gspca/spca508\.c,drivers/media/usb/gspca/spca508\.c,g' \
	-e 's,drivers/media/video/gspca/spca561\.c,drivers/media/usb/gspca/spca561\.c,g' \
	-e 's,drivers/media/video/gspca/sq905\.c,drivers/media/usb/gspca/sq905\.c,g' \
	-e 's,drivers/media/video/gspca/sq905c\.c,drivers/media/usb/gspca/sq905c\.c,g' \
	-e 's,drivers/media/video/gspca/sq930x\.c,drivers/media/usb/gspca/sq930x\.c,g' \
	-e 's,drivers/media/video/gspca/stk014\.c,drivers/media/usb/gspca/stk014\.c,g' \
	-e 's,drivers/media/video/gspca/stv0680\.c,drivers/media/usb/gspca/stv0680\.c,g' \
	-e 's,drivers/media/video/gspca/stv06xx/Kconfig,drivers/media/usb/gspca/stv06xx/Kconfig,g' \
	-e 's,drivers/media/video/gspca/stv06xx/Makefile,drivers/media/usb/gspca/stv06xx/Makefile,g' \
	-e 's,drivers/media/video/gspca/stv06xx/stv06xx\.c,drivers/media/usb/gspca/stv06xx/stv06xx\.c,g' \
	-e 's,drivers/media/video/gspca/stv06xx/stv06xx\.h,drivers/media/usb/gspca/stv06xx/stv06xx\.h,g' \
	-e 's,drivers/media/video/gspca/stv06xx/stv06xx_hdcs\.c,drivers/media/usb/gspca/stv06xx/stv06xx_hdcs\.c,g' \
	-e 's,drivers/media/video/gspca/stv06xx/stv06xx_hdcs\.h,drivers/media/usb/gspca/stv06xx/stv06xx_hdcs\.h,g' \
	-e 's,drivers/media/video/gspca/stv06xx/stv06xx_pb0100\.c,drivers/media/usb/gspca/stv06xx/stv06xx_pb0100\.c,g' \
	-e 's,drivers/media/video/gspca/stv06xx/stv06xx_pb0100\.h,drivers/media/usb/gspca/stv06xx/stv06xx_pb0100\.h,g' \
	-e 's,drivers/media/video/gspca/stv06xx/stv06xx_sensor\.h,drivers/media/usb/gspca/stv06xx/stv06xx_sensor\.h,g' \
	-e 's,drivers/media/video/gspca/stv06xx/stv06xx_st6422\.c,drivers/media/usb/gspca/stv06xx/stv06xx_st6422\.c,g' \
	-e 's,drivers/media/video/gspca/stv06xx/stv06xx_st6422\.h,drivers/media/usb/gspca/stv06xx/stv06xx_st6422\.h,g' \
	-e 's,drivers/media/video/gspca/stv06xx/stv06xx_vv6410\.c,drivers/media/usb/gspca/stv06xx/stv06xx_vv6410\.c,g' \
	-e 's,drivers/media/video/gspca/stv06xx/stv06xx_vv6410\.h,drivers/media/usb/gspca/stv06xx/stv06xx_vv6410\.h,g' \
	-e 's,drivers/media/video/gspca/sunplus\.c,drivers/media/usb/gspca/sunplus\.c,g' \
	-e 's,drivers/media/video/gspca/t613\.c,drivers/media/usb/gspca/t613\.c,g' \
	-e 's,drivers/media/video/gspca/topro\.c,drivers/media/usb/gspca/topro\.c,g' \
	-e 's,drivers/media/video/gspca/tv8532\.c,drivers/media/usb/gspca/tv8532\.c,g' \
	-e 's,drivers/media/video/gspca/vc032x\.c,drivers/media/usb/gspca/vc032x\.c,g' \
	-e 's,drivers/media/video/gspca/vicam\.c,drivers/media/usb/gspca/vicam\.c,g' \
	-e 's,drivers/media/video/gspca/w996Xcf\.c,drivers/media/usb/gspca/w996Xcf\.c,g' \
	-e 's,drivers/media/video/gspca/xirlink_cit\.c,drivers/media/usb/gspca/xirlink_cit\.c,g' \
	-e 's,drivers/media/video/gspca/zc3xx-reg\.h,drivers/media/usb/gspca/zc3xx-reg\.h,g' \
	-e 's,drivers/media/video/gspca/zc3xx\.c,drivers/media/usb/gspca/zc3xx\.c,g' \
	-e 's,drivers/media/video/hdpvr/Kconfig,drivers/media/usb/hdpvr/Kconfig,g' \
	-e 's,drivers/media/video/hdpvr/Makefile,drivers/media/usb/hdpvr/Makefile,g' \
	-e 's,drivers/media/video/hdpvr/hdpvr-control\.c,drivers/media/usb/hdpvr/hdpvr-control\.c,g' \
	-e 's,drivers/media/video/hdpvr/hdpvr-core\.c,drivers/media/usb/hdpvr/hdpvr-core\.c,g' \
	-e 's,drivers/media/video/hdpvr/hdpvr-i2c\.c,drivers/media/usb/hdpvr/hdpvr-i2c\.c,g' \
	-e 's,drivers/media/video/hdpvr/hdpvr-video\.c,drivers/media/usb/hdpvr/hdpvr-video\.c,g' \
	-e 's,drivers/media/video/hdpvr/hdpvr\.h,drivers/media/usb/hdpvr/hdpvr\.h,g' \
	-e 's,drivers/media/video/pvrusb2/Kconfig,drivers/media/usb/pvrusb2/Kconfig,g' \
	-e 's,drivers/media/video/pvrusb2/Makefile,drivers/media/usb/pvrusb2/Makefile,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-audio\.c,drivers/media/usb/pvrusb2/pvrusb2-audio\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-audio\.h,drivers/media/usb/pvrusb2/pvrusb2-audio\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-context\.c,drivers/media/usb/pvrusb2/pvrusb2-context\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-context\.h,drivers/media/usb/pvrusb2/pvrusb2-context\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-cs53l32a\.c,drivers/media/usb/pvrusb2/pvrusb2-cs53l32a\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-cs53l32a\.h,drivers/media/usb/pvrusb2/pvrusb2-cs53l32a\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-ctrl\.c,drivers/media/usb/pvrusb2/pvrusb2-ctrl\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-ctrl\.h,drivers/media/usb/pvrusb2/pvrusb2-ctrl\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-cx2584x-v4l\.c,drivers/media/usb/pvrusb2/pvrusb2-cx2584x-v4l\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-cx2584x-v4l\.h,drivers/media/usb/pvrusb2/pvrusb2-cx2584x-v4l\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-debug\.h,drivers/media/usb/pvrusb2/pvrusb2-debug\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-debugifc\.c,drivers/media/usb/pvrusb2/pvrusb2-debugifc\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-debugifc\.h,drivers/media/usb/pvrusb2/pvrusb2-debugifc\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-devattr\.c,drivers/media/usb/pvrusb2/pvrusb2-devattr\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-devattr\.h,drivers/media/usb/pvrusb2/pvrusb2-devattr\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-dvb\.c,drivers/media/usb/pvrusb2/pvrusb2-dvb\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-dvb\.h,drivers/media/usb/pvrusb2/pvrusb2-dvb\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-eeprom\.c,drivers/media/usb/pvrusb2/pvrusb2-eeprom\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-eeprom\.h,drivers/media/usb/pvrusb2/pvrusb2-eeprom\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-encoder\.c,drivers/media/usb/pvrusb2/pvrusb2-encoder\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-encoder\.h,drivers/media/usb/pvrusb2/pvrusb2-encoder\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-fx2-cmd\.h,drivers/media/usb/pvrusb2/pvrusb2-fx2-cmd\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-hdw-internal\.h,drivers/media/usb/pvrusb2/pvrusb2-hdw-internal\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-hdw\.c,drivers/media/usb/pvrusb2/pvrusb2-hdw\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-hdw\.h,drivers/media/usb/pvrusb2/pvrusb2-hdw\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-i2c-core\.c,drivers/media/usb/pvrusb2/pvrusb2-i2c-core\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-i2c-core\.h,drivers/media/usb/pvrusb2/pvrusb2-i2c-core\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-io\.c,drivers/media/usb/pvrusb2/pvrusb2-io\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-io\.h,drivers/media/usb/pvrusb2/pvrusb2-io\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-ioread\.c,drivers/media/usb/pvrusb2/pvrusb2-ioread\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-ioread\.h,drivers/media/usb/pvrusb2/pvrusb2-ioread\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-main\.c,drivers/media/usb/pvrusb2/pvrusb2-main\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-std\.c,drivers/media/usb/pvrusb2/pvrusb2-std\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-std\.h,drivers/media/usb/pvrusb2/pvrusb2-std\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-sysfs\.c,drivers/media/usb/pvrusb2/pvrusb2-sysfs\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-sysfs\.h,drivers/media/usb/pvrusb2/pvrusb2-sysfs\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-util\.h,drivers/media/usb/pvrusb2/pvrusb2-util\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-v4l2\.c,drivers/media/usb/pvrusb2/pvrusb2-v4l2\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-v4l2\.h,drivers/media/usb/pvrusb2/pvrusb2-v4l2\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-video-v4l\.c,drivers/media/usb/pvrusb2/pvrusb2-video-v4l\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-video-v4l\.h,drivers/media/usb/pvrusb2/pvrusb2-video-v4l\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-wm8775\.c,drivers/media/usb/pvrusb2/pvrusb2-wm8775\.c,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2-wm8775\.h,drivers/media/usb/pvrusb2/pvrusb2-wm8775\.h,g' \
	-e 's,drivers/media/video/pvrusb2/pvrusb2\.h,drivers/media/usb/pvrusb2/pvrusb2\.h,g' \
	-e 's,drivers/media/video/pwc/Kconfig,drivers/media/usb/pwc/Kconfig,g' \
	-e 's,drivers/media/video/pwc/Makefile,drivers/media/usb/pwc/Makefile,g' \
	-e 's,drivers/media/video/pwc/philips\.txt,drivers/media/usb/pwc/philips\.txt,g' \
	-e 's,drivers/media/video/pwc/pwc-ctrl\.c,drivers/media/usb/pwc/pwc-ctrl\.c,g' \
	-e 's,drivers/media/video/pwc/pwc-dec1\.c,drivers/media/usb/pwc/pwc-dec1\.c,g' \
	-e 's,drivers/media/video/pwc/pwc-dec1\.h,drivers/media/usb/pwc/pwc-dec1\.h,g' \
	-e 's,drivers/media/video/pwc/pwc-dec23\.c,drivers/media/usb/pwc/pwc-dec23\.c,g' \
	-e 's,drivers/media/video/pwc/pwc-dec23\.h,drivers/media/usb/pwc/pwc-dec23\.h,g' \
	-e 's,drivers/media/video/pwc/pwc-if\.c,drivers/media/usb/pwc/pwc-if\.c,g' \
	-e 's,drivers/media/video/pwc/pwc-kiara\.c,drivers/media/usb/pwc/pwc-kiara\.c,g' \
	-e 's,drivers/media/video/pwc/pwc-kiara\.h,drivers/media/usb/pwc/pwc-kiara\.h,g' \
	-e 's,drivers/media/video/pwc/pwc-misc\.c,drivers/media/usb/pwc/pwc-misc\.c,g' \
	-e 's,drivers/media/video/pwc/pwc-nala\.h,drivers/media/usb/pwc/pwc-nala\.h,g' \
	-e 's,drivers/media/video/pwc/pwc-timon\.c,drivers/media/usb/pwc/pwc-timon\.c,g' \
	-e 's,drivers/media/video/pwc/pwc-timon\.h,drivers/media/usb/pwc/pwc-timon\.h,g' \
	-e 's,drivers/media/video/pwc/pwc-uncompress\.c,drivers/media/usb/pwc/pwc-uncompress\.c,g' \
	-e 's,drivers/media/video/pwc/pwc-v4l\.c,drivers/media/usb/pwc/pwc-v4l\.c,g' \
	-e 's,drivers/media/video/pwc/pwc\.h,drivers/media/usb/pwc/pwc\.h,g' \
	-e 's,drivers/media/video/s2255drv\.c,drivers/media/usb/s2255/s2255drv\.c,g' \
	-e 's,drivers/media/dvb/siano/smsusb\.c,drivers/media/usb/siano/smsusb\.c,g' \
	-e 's,drivers/media/video/sn9c102/Kconfig,drivers/media/usb/sn9c102/Kconfig,g' \
	-e 's,drivers/media/video/sn9c102/Makefile,drivers/media/usb/sn9c102/Makefile,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102\.h,drivers/media/usb/sn9c102/sn9c102\.h,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_config\.h,drivers/media/usb/sn9c102/sn9c102_config\.h,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_core\.c,drivers/media/usb/sn9c102/sn9c102_core\.c,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_devtable\.h,drivers/media/usb/sn9c102/sn9c102_devtable\.h,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_hv7131d\.c,drivers/media/usb/sn9c102/sn9c102_hv7131d\.c,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_hv7131r\.c,drivers/media/usb/sn9c102/sn9c102_hv7131r\.c,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_mi0343\.c,drivers/media/usb/sn9c102/sn9c102_mi0343\.c,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_mi0360\.c,drivers/media/usb/sn9c102/sn9c102_mi0360\.c,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_mt9v111\.c,drivers/media/usb/sn9c102/sn9c102_mt9v111\.c,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_ov7630\.c,drivers/media/usb/sn9c102/sn9c102_ov7630\.c,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_ov7660\.c,drivers/media/usb/sn9c102/sn9c102_ov7660\.c,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_pas106b\.c,drivers/media/usb/sn9c102/sn9c102_pas106b\.c,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_pas202bcb\.c,drivers/media/usb/sn9c102/sn9c102_pas202bcb\.c,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_sensor\.h,drivers/media/usb/sn9c102/sn9c102_sensor\.h,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_tas5110c1b\.c,drivers/media/usb/sn9c102/sn9c102_tas5110c1b\.c,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_tas5110d\.c,drivers/media/usb/sn9c102/sn9c102_tas5110d\.c,g' \
	-e 's,drivers/media/video/sn9c102/sn9c102_tas5130d1b\.c,drivers/media/usb/sn9c102/sn9c102_tas5130d1b\.c,g' \
	-e 's,drivers/media/video/stk1160/Kconfig,drivers/media/usb/stk1160/Kconfig,g' \
	-e 's,drivers/media/video/stk1160/Makefile,drivers/media/usb/stk1160/Makefile,g' \
	-e 's,drivers/media/video/stk1160/stk1160-ac97\.c,drivers/media/usb/stk1160/stk1160-ac97\.c,g' \
	-e 's,drivers/media/video/stk1160/stk1160-core\.c,drivers/media/usb/stk1160/stk1160-core\.c,g' \
	-e 's,drivers/media/video/stk1160/stk1160-i2c\.c,drivers/media/usb/stk1160/stk1160-i2c\.c,g' \
	-e 's,drivers/media/video/stk1160/stk1160-reg\.h,drivers/media/usb/stk1160/stk1160-reg\.h,g' \
	-e 's,drivers/media/video/stk1160/stk1160-v4l\.c,drivers/media/usb/stk1160/stk1160-v4l\.c,g' \
	-e 's,drivers/media/video/stk1160/stk1160-video\.c,drivers/media/usb/stk1160/stk1160-video\.c,g' \
	-e 's,drivers/media/video/stk1160/stk1160\.h,drivers/media/usb/stk1160/stk1160\.h,g' \
	-e 's,drivers/media/video/stk-sensor\.c,drivers/media/usb/stkwebcam/stk-sensor\.c,g' \
	-e 's,drivers/media/video/stk-webcam\.c,drivers/media/usb/stkwebcam/stk-webcam\.c,g' \
	-e 's,drivers/media/video/stk-webcam\.h,drivers/media/usb/stkwebcam/stk-webcam\.h,g' \
	-e 's,drivers/media/video/tlg2300/Kconfig,drivers/media/usb/tlg2300/Kconfig,g' \
	-e 's,drivers/media/video/tlg2300/Makefile,drivers/media/usb/tlg2300/Makefile,g' \
	-e 's,drivers/media/video/tlg2300/pd-alsa\.c,drivers/media/usb/tlg2300/pd-alsa\.c,g' \
	-e 's,drivers/media/video/tlg2300/pd-common\.h,drivers/media/usb/tlg2300/pd-common\.h,g' \
	-e 's,drivers/media/video/tlg2300/pd-dvb\.c,drivers/media/usb/tlg2300/pd-dvb\.c,g' \
	-e 's,drivers/media/video/tlg2300/pd-main\.c,drivers/media/usb/tlg2300/pd-main\.c,g' \
	-e 's,drivers/media/video/tlg2300/pd-radio\.c,drivers/media/usb/tlg2300/pd-radio\.c,g' \
	-e 's,drivers/media/video/tlg2300/pd-video\.c,drivers/media/usb/tlg2300/pd-video\.c,g' \
	-e 's,drivers/media/video/tlg2300/vendorcmds\.h,drivers/media/usb/tlg2300/vendorcmds\.h,g' \
	-e 's,drivers/media/video/tm6000/Kconfig,drivers/media/usb/tm6000/Kconfig,g' \
	-e 's,drivers/media/video/tm6000/Makefile,drivers/media/usb/tm6000/Makefile,g' \
	-e 's,drivers/media/video/tm6000/tm6000-alsa\.c,drivers/media/usb/tm6000/tm6000-alsa\.c,g' \
	-e 's,drivers/media/video/tm6000/tm6000-cards\.c,drivers/media/usb/tm6000/tm6000-cards\.c,g' \
	-e 's,drivers/media/video/tm6000/tm6000-core\.c,drivers/media/usb/tm6000/tm6000-core\.c,g' \
	-e 's,drivers/media/video/tm6000/tm6000-dvb\.c,drivers/media/usb/tm6000/tm6000-dvb\.c,g' \
	-e 's,drivers/media/video/tm6000/tm6000-i2c\.c,drivers/media/usb/tm6000/tm6000-i2c\.c,g' \
	-e 's,drivers/media/video/tm6000/tm6000-input\.c,drivers/media/usb/tm6000/tm6000-input\.c,g' \
	-e 's,drivers/media/video/tm6000/tm6000-regs\.h,drivers/media/usb/tm6000/tm6000-regs\.h,g' \
	-e 's,drivers/media/video/tm6000/tm6000-stds\.c,drivers/media/usb/tm6000/tm6000-stds\.c,g' \
	-e 's,drivers/media/video/tm6000/tm6000-usb-isoc\.h,drivers/media/usb/tm6000/tm6000-usb-isoc\.h,g' \
	-e 's,drivers/media/video/tm6000/tm6000-video\.c,drivers/media/usb/tm6000/tm6000-video\.c,g' \
	-e 's,drivers/media/video/tm6000/tm6000\.h,drivers/media/usb/tm6000/tm6000\.h,g' \
	-e 's,drivers/media/dvb/ttusb-budget/Kconfig,drivers/media/usb/ttusb-budget/Kconfig,g' \
	-e 's,drivers/media/dvb/ttusb-budget/Makefile,drivers/media/usb/ttusb-budget/Makefile,g' \
	-e 's,drivers/media/dvb/ttusb-budget/dvb-ttusb-budget\.c,drivers/media/usb/ttusb-budget/dvb-ttusb-budget\.c,g' \
	-e 's,drivers/media/dvb/ttusb-dec/Kconfig,drivers/media/usb/ttusb-dec/Kconfig,g' \
	-e 's,drivers/media/dvb/ttusb-dec/Makefile,drivers/media/usb/ttusb-dec/Makefile,g' \
	-e 's,drivers/media/dvb/ttusb-dec/ttusb_dec\.c,drivers/media/usb/ttusb-dec/ttusb_dec\.c,g' \
	-e 's,drivers/media/dvb/ttusb-dec/ttusbdecfe\.c,drivers/media/usb/ttusb-dec/ttusbdecfe\.c,g' \
	-e 's,drivers/media/dvb/ttusb-dec/ttusbdecfe\.h,drivers/media/usb/ttusb-dec/ttusbdecfe\.h,g' \
	-e 's,drivers/media/video/usbvision/Kconfig,drivers/media/usb/usbvision/Kconfig,g' \
	-e 's,drivers/media/video/usbvision/Makefile,drivers/media/usb/usbvision/Makefile,g' \
	-e 's,drivers/media/video/usbvision/usbvision-cards\.c,drivers/media/usb/usbvision/usbvision-cards\.c,g' \
	-e 's,drivers/media/video/usbvision/usbvision-cards\.h,drivers/media/usb/usbvision/usbvision-cards\.h,g' \
	-e 's,drivers/media/video/usbvision/usbvision-core\.c,drivers/media/usb/usbvision/usbvision-core\.c,g' \
	-e 's,drivers/media/video/usbvision/usbvision-i2c\.c,drivers/media/usb/usbvision/usbvision-i2c\.c,g' \
	-e 's,drivers/media/video/usbvision/usbvision-video\.c,drivers/media/usb/usbvision/usbvision-video\.c,g' \
	-e 's,drivers/media/video/usbvision/usbvision\.h,drivers/media/usb/usbvision/usbvision\.h,g' \
	-e 's,drivers/media/video/uvc/Kconfig,drivers/media/usb/uvc/Kconfig,g' \
	-e 's,drivers/media/video/uvc/Makefile,drivers/media/usb/uvc/Makefile,g' \
	-e 's,drivers/media/video/uvc/uvc_ctrl\.c,drivers/media/usb/uvc/uvc_ctrl\.c,g' \
	-e 's,drivers/media/video/uvc/uvc_debugfs\.c,drivers/media/usb/uvc/uvc_debugfs\.c,g' \
	-e 's,drivers/media/video/uvc/uvc_driver\.c,drivers/media/usb/uvc/uvc_driver\.c,g' \
	-e 's,drivers/media/video/uvc/uvc_entity\.c,drivers/media/usb/uvc/uvc_entity\.c,g' \
	-e 's,drivers/media/video/uvc/uvc_isight\.c,drivers/media/usb/uvc/uvc_isight\.c,g' \
	-e 's,drivers/media/video/uvc/uvc_queue\.c,drivers/media/usb/uvc/uvc_queue\.c,g' \
	-e 's,drivers/media/video/uvc/uvc_status\.c,drivers/media/usb/uvc/uvc_status\.c,g' \
	-e 's,drivers/media/video/uvc/uvc_v4l2\.c,drivers/media/usb/uvc/uvc_v4l2\.c,g' \
	-e 's,drivers/media/video/uvc/uvc_video\.c,drivers/media/usb/uvc/uvc_video\.c,g' \
	-e 's,drivers/media/video/uvc/uvcvideo\.h,drivers/media/usb/uvc/uvcvideo\.h,g' \
	-e 's,drivers/media/video/zr364xx\.c,drivers/media/usb/zr364xx/zr364xx\.c,g' \
	-e 's,drivers/media/video/tuner-core\.c,drivers/media/v4l2-core/tuner-core\.c,g' \
	-e 's,drivers/media/video/v4l2-common\.c,drivers/media/v4l2-core/v4l2-common\.c,g' \
	-e 's,drivers/media/video/v4l2-compat-ioctl32\.c,drivers/media/v4l2-core/v4l2-compat-ioctl32\.c,g' \
	-e 's,drivers/media/video/v4l2-ctrls\.c,drivers/media/v4l2-core/v4l2-ctrls\.c,g' \
	-e 's,drivers/media/video/v4l2-dev\.c,drivers/media/v4l2-core/v4l2-dev\.c,g' \
	-e 's,drivers/media/video/v4l2-device\.c,drivers/media/v4l2-core/v4l2-device\.c,g' \
	-e 's,drivers/media/video/v4l2-event\.c,drivers/media/v4l2-core/v4l2-event\.c,g' \
	-e 's,drivers/media/video/v4l2-fh\.c,drivers/media/v4l2-core/v4l2-fh\.c,g' \
	-e 's,drivers/media/video/v4l2-int-device\.c,drivers/media/v4l2-core/v4l2-int-device\.c,g' \
	-e 's,drivers/media/video/v4l2-ioctl\.c,drivers/media/v4l2-core/v4l2-ioctl\.c,g' \
	-e 's,drivers/media/video/v4l2-mem2mem\.c,drivers/media/v4l2-core/v4l2-mem2mem\.c,g' \
	-e 's,drivers/media/video/v4l2-subdev\.c,drivers/media/v4l2-core/v4l2-subdev\.c,g' \
	-e 's,drivers/media/video/videobuf-core\.c,drivers/media/v4l2-core/videobuf-core\.c,g' \
	-e 's,drivers/media/video/videobuf-dma-contig\.c,drivers/media/v4l2-core/videobuf-dma-contig\.c,g' \
	-e 's,drivers/media/video/videobuf-dma-sg\.c,drivers/media/v4l2-core/videobuf-dma-sg\.c,g' \
	-e 's,drivers/media/video/videobuf-dvb\.c,drivers/media/v4l2-core/videobuf-dvb\.c,g' \
	-e 's,drivers/media/video/videobuf-vmalloc\.c,drivers/media/v4l2-core/videobuf-vmalloc\.c,g' \
	-e 's,drivers/media/video/videobuf2-core\.c,drivers/media/v4l2-core/videobuf2-core\.c,g' \
	-e 's,drivers/media/video/videobuf2-dma-contig\.c,drivers/media/v4l2-core/videobuf2-dma-contig\.c,g' \
	-e 's,drivers/media/video/videobuf2-dma-sg\.c,drivers/media/v4l2-core/videobuf2-dma-sg\.c,g' \
	-e 's,drivers/media/video/videobuf2-memops\.c,drivers/media/v4l2-core/videobuf2-memops\.c,g' \
	-e 's,drivers/media/video/videobuf2-vmalloc\.c,drivers/media/v4l2-core/videobuf2-vmalloc\.c,g' \
 >$1 && \
echo -e "old patch stored as "$OLD"\n$1 rewrote."
